# Makefile for the rml compiler and interpreter
SHELL=/bin/sh
GOROOT=..

GENERATED=lexer/rml.lex.sml parser/rml.grm.sml parser/rml.grm.sig main/make.sml
TEMP=$(GENERATED) parser/rml.grm.desc

default:	rml

rml rml.$(HEAP_SUFFIX):	$(GENERATED)
	cat main/make.sml | $(SMLCM)
	ls -l rml.$(HEAP_SUFFIX)

install:	install-rml

install-rml:	rml.$(HEAP_SUFFIX)
	$(GOROOT)/etc/install-sml rml $(PREFIX) $(SMLCM) $(HEAP_SUFFIX) $(GOROOT)

lexer/rml.lex.sml:	lexer/rml.lex
	$(MLLEX) lexer/rml.lex

parser/rml.grm.sml parser/rml.grm.sig:	parser/rml.grm
	$(MLYACC) parser/rml.grm

Makefile:	$(GOROOT)/config.cache Make.mk
	(echo include $(GOROOT)/config.cache; cat Make.mk) > Makefile

main/make.sml:	$(GOROOT)/config.cache
	. $(GOROOT)/config.cache; main/mkmake.sh $$SMLCM > main/make.sml || (rm -f main/make.sml; exit 1)

configure:	clean-configure Makefile main/make.sml

clean-configure:
	rm -f Makefile

distclean:	realclean clean-configure

realclean:
	rm -f rml.*-*
	rm -rf */CM
	rm -f $(TEMP)

clean:
	rm -f rml.*-*
