(* main/control.sml *)

signature CONTROL =
  sig


    (* options for ReorderParse *)
    val doReorder: bool ref

    (* options for TypeCheck / StatElab *)
    val allowImplicitLet: bool ref

    (* options for FOLToCPS *)
    val warnNonExhaustive: bool ref

    (* options for CodeToC *)
    val switchRewriteThreshold: int ref

    (* -- start options for Debbuging (added by adrpo@ida.liu.se 2002-06-14) *)
    val doTrace: bool ref
    (* -- end adrpo@ida.liu.se 2002-06-14 *)

  end (* signature CONTROL *)

structure Control : CONTROL =
  struct

    (* options for ReorderParse *)
    val doReorder = ref true

    (* options for TypeCheck / StatElab *)
    val allowImplicitLet = ref false

    (* options for FOLToCPS *)
    val warnNonExhaustive = ref false

    (* options for CodeToC *)
    val switchRewriteThreshold = ref 3

    (* options for Debbuging (added by adrpo@ida.liu.se 2002-06-14) *)
    val doTrace = ref false;
    (* --end adrpo@ida.liu.se 2002-06-14 *)

  end (* structure Control *)


