
functor RMLLrValsFn(structure Token : TOKEN
			     structure Absyn : ABSYN
			     structure LexArg : LEXARG) : RML_LRVALS = 
struct
structure ParserData=
struct
structure Header = 
struct
(* parser/rml.grm -- ML-Yacc grammar for RML *)

fun mklst(xlst, xnil, xcons) =
  let fun loop([], rest) = rest
	| loop(x::xlst, rest) = loop(xlst, xcons(x,rest))
  in
    loop(rev xlst, xnil)
  end

fun makeInfo myLoc (left, right) =
	let val {fileName, sline, scolumn, eline, ecolumn} = myLoc (left, right)
		val loc_ref = ref(Absyn.LOC(sline, scolumn, eline, ecolumn))
	in 
	  ref(Absyn.INFO(fileName, left, right, loc_ref))
	end


val modidRML = SOME(Absyn.rmlIdent "RML")
val id_cons = Absyn.LONGID(modidRML, Absyn.rmlIdent "cons", ref(Absyn.dummyInfo))
val ctor_cons = SOME id_cons
val id_nil = Absyn.LONGID(modidRML, Absyn.rmlIdent "nil", ref(Absyn.dummyInfo))

(* operators *)
(* ///////--- int operators ---////////*)
val op_add_int = Absyn.LONGID(modidRML, Absyn.rmlIdent "int_add", ref(Absyn.dummyInfo))
val op_sub_int = Absyn.LONGID(modidRML, Absyn.rmlIdent "int_sub", ref(Absyn.dummyInfo))
val op_neg_int = Absyn.LONGID(modidRML, Absyn.rmlIdent "int_neg", ref(Absyn.dummyInfo))
val op_mul_int = Absyn.LONGID(modidRML, Absyn.rmlIdent "int_mul", ref(Absyn.dummyInfo))
val op_div_int = Absyn.LONGID(modidRML, Absyn.rmlIdent "int_div", ref(Absyn.dummyInfo))
val op_mod_int = Absyn.LONGID(modidRML, Absyn.rmlIdent "int_mod", ref(Absyn.dummyInfo))
val op_eq_int = Absyn.LONGID(modidRML, Absyn.rmlIdent "int_eq", ref(Absyn.dummyInfo))
val op_ge_int = Absyn.LONGID(modidRML, Absyn.rmlIdent "int_ge", ref(Absyn.dummyInfo))
val op_gt_int = Absyn.LONGID(modidRML, Absyn.rmlIdent "int_gt", ref(Absyn.dummyInfo))
val op_le_int = Absyn.LONGID(modidRML, Absyn.rmlIdent "int_le", ref(Absyn.dummyInfo))
val op_lt_int = Absyn.LONGID(modidRML, Absyn.rmlIdent "int_lt", ref(Absyn.dummyInfo))
val op_ne_int = Absyn.LONGID(modidRML, Absyn.rmlIdent "int_ne", ref(Absyn.dummyInfo))
(* ///////--- real operators ---////////*)
val op_add_real = Absyn.LONGID(modidRML, Absyn.rmlIdent "real_add", ref(Absyn.dummyInfo))
val op_sub_real = Absyn.LONGID(modidRML, Absyn.rmlIdent "real_sub", ref(Absyn.dummyInfo))
val op_neg_real = Absyn.LONGID(modidRML, Absyn.rmlIdent "real_neg", ref(Absyn.dummyInfo))
val op_mul_real = Absyn.LONGID(modidRML, Absyn.rmlIdent "real_mul", ref(Absyn.dummyInfo))
val op_div_real = Absyn.LONGID(modidRML, Absyn.rmlIdent "real_div", ref(Absyn.dummyInfo))
val op_mod_real = Absyn.LONGID(modidRML, Absyn.rmlIdent "real_mod", ref(Absyn.dummyInfo))
val op_pow_real = Absyn.LONGID(modidRML, Absyn.rmlIdent "real_pow", ref(Absyn.dummyInfo))
val op_eq_real = Absyn.LONGID(modidRML, Absyn.rmlIdent "real_eq", ref(Absyn.dummyInfo))
val op_ge_real = Absyn.LONGID(modidRML, Absyn.rmlIdent "real_ge", ref(Absyn.dummyInfo))
val op_gt_real = Absyn.LONGID(modidRML, Absyn.rmlIdent "real_gt", ref(Absyn.dummyInfo))
val op_le_real = Absyn.LONGID(modidRML, Absyn.rmlIdent "real_le", ref(Absyn.dummyInfo))
val op_lt_real = Absyn.LONGID(modidRML, Absyn.rmlIdent "real_lt", ref(Absyn.dummyInfo))
val op_ne_real = Absyn.LONGID(modidRML, Absyn.rmlIdent "real_ne", ref(Absyn.dummyInfo))
(* ///////--- string operators ---////////*)
val op_add_string = Absyn.LONGID(modidRML, Absyn.rmlIdent "string_append", ref(Absyn.dummyInfo))
(* ///////--- list operators ---////////*)
val op_add_list = Absyn.LONGID(modidRML, Absyn.rmlIdent "list_append", ref(Absyn.dummyInfo))


val exp_nil = Absyn.CONexp(id_nil, ref(Absyn.dummyInfo))
fun exp_cons(e,es) = Absyn.STRUCTexp(ctor_cons, [e,es], ref(Absyn.dummyInfo))
fun mkexplst lst = mklst(lst, exp_nil, exp_cons)

val pat_nil = Absyn.CONpat(id_nil, ref(Absyn.dummyInfo))
fun pat_cons(p,ps) = Absyn.STRUCTpat(ctor_cons, [p,ps], ref(Absyn.dummyInfo))
fun mkpatlst lst = mklst(lst, pat_nil, pat_cons)

fun mktuplety([ty]) = ty
  | mktuplety(tyseq) = Absyn.TUPLEty(tyseq, ref(Absyn.dummyInfo))

fun join_default(c1, NONE) = c1
  | join_default(c1, SOME c2) =
      let fun join(c1 as Absyn.CLAUSE1 _) = 
			Absyn.CLAUSE2(c1, c2, ref(Absyn.dummyInfo))
	    | join(Absyn.CLAUSE2(c11,c12, _)) = 
			Absyn.CLAUSE2(c11, join c12, ref(Absyn.dummyInfo))
      in
		join c1
      end

end
structure LrTable = Token.LrTable
structure Token = Token
local open LrTable in 
val table=let val actionRows =
"\
\\001\000\001\000\108\001\010\000\108\001\032\000\108\001\000\000\
\\001\000\001\000\109\001\010\000\109\001\032\000\109\001\000\000\
\\001\000\001\000\110\001\010\000\110\001\032\000\110\001\000\000\
\\001\000\001\000\111\001\010\000\111\001\032\000\111\001\000\000\
\\001\000\001\000\112\001\010\000\112\001\032\000\112\001\000\000\
\\001\000\001\000\113\001\010\000\113\001\032\000\113\001\000\000\
\\001\000\001\000\114\001\010\000\114\001\032\000\114\001\000\000\
\\001\000\001\000\115\001\010\000\115\001\032\000\115\001\000\000\
\\001\000\001\000\116\001\010\000\116\001\032\000\116\001\000\000\
\\001\000\001\000\117\001\010\000\117\001\032\000\117\001\000\000\
\\001\000\001\000\118\001\010\000\118\001\032\000\118\001\000\000\
\\001\000\001\000\119\001\010\000\119\001\032\000\119\001\000\000\
\\001\000\001\000\120\001\010\000\120\001\032\000\120\001\000\000\
\\001\000\001\000\121\001\010\000\121\001\032\000\121\001\000\000\
\\001\000\001\000\122\001\010\000\122\001\032\000\122\001\000\000\
\\001\000\001\000\123\001\010\000\123\001\032\000\123\001\000\000\
\\001\000\001\000\124\001\010\000\124\001\032\000\124\001\000\000\
\\001\000\001\000\125\001\010\000\125\001\032\000\125\001\000\000\
\\001\000\001\000\126\001\010\000\126\001\032\000\126\001\000\000\
\\001\000\001\000\127\001\010\000\127\001\032\000\127\001\000\000\
\\001\000\001\000\128\001\010\000\128\001\032\000\128\001\000\000\
\\001\000\001\000\129\001\010\000\129\001\032\000\129\001\000\000\
\\001\000\001\000\130\001\010\000\130\001\032\000\130\001\000\000\
\\001\000\001\000\131\001\010\000\131\001\032\000\131\001\000\000\
\\001\000\001\000\132\001\010\000\132\001\032\000\132\001\000\000\
\\001\000\001\000\133\001\010\000\133\001\032\000\133\001\000\000\
\\001\000\001\000\134\001\010\000\134\001\032\000\134\001\000\000\
\\001\000\001\000\136\001\010\000\136\001\032\000\136\001\000\000\
\\001\000\001\000\137\001\010\000\137\001\032\000\137\001\000\000\
\\001\000\001\000\138\001\010\000\138\001\032\000\138\001\000\000\
\\001\000\001\000\139\001\010\000\139\001\032\000\139\001\000\000\
\\001\000\001\000\140\001\009\000\140\001\010\000\140\001\011\000\140\001\
\\016\000\140\001\030\000\140\001\031\000\140\001\032\000\140\001\
\\038\000\140\001\040\000\140\001\042\000\140\001\000\000\
\\001\000\001\000\141\001\008\000\103\000\009\000\141\001\010\000\141\001\
\\011\000\141\001\016\000\141\001\030\000\141\001\031\000\141\001\
\\032\000\141\001\038\000\141\001\040\000\141\001\042\000\141\001\000\000\
\\001\000\001\000\142\001\008\000\142\001\009\000\142\001\010\000\142\001\
\\011\000\142\001\016\000\142\001\030\000\142\001\031\000\142\001\
\\032\000\142\001\038\000\142\001\040\000\142\001\042\000\142\001\000\000\
\\001\000\001\000\143\001\008\000\143\001\009\000\143\001\010\000\143\001\
\\011\000\143\001\016\000\143\001\030\000\143\001\031\000\143\001\
\\032\000\143\001\038\000\143\001\040\000\143\001\042\000\143\001\000\000\
\\001\000\001\000\144\001\008\000\144\001\009\000\144\001\010\000\144\001\
\\011\000\144\001\016\000\144\001\030\000\144\001\031\000\144\001\
\\032\000\144\001\038\000\144\001\040\000\144\001\042\000\144\001\000\000\
\\001\000\001\000\145\001\008\000\145\001\009\000\145\001\010\000\145\001\
\\011\000\145\001\016\000\145\001\030\000\145\001\031\000\145\001\
\\032\000\145\001\038\000\145\001\040\000\145\001\042\000\145\001\000\000\
\\001\000\001\000\146\001\004\000\146\001\010\000\146\001\012\000\146\001\
\\014\000\146\001\020\000\146\001\032\000\146\001\033\000\146\001\000\000\
\\001\000\001\000\147\001\004\000\147\001\008\000\225\000\010\000\147\001\
\\012\000\147\001\014\000\147\001\020\000\147\001\032\000\147\001\
\\033\000\147\001\000\000\
\\001\000\001\000\148\001\004\000\148\001\008\000\148\001\009\000\148\001\
\\010\000\148\001\011\000\148\001\012\000\148\001\014\000\148\001\
\\016\000\148\001\020\000\148\001\030\000\148\001\031\000\148\001\
\\032\000\148\001\033\000\148\001\038\000\148\001\040\000\148\001\
\\042\000\148\001\000\000\
\\001\000\001\000\149\001\004\000\149\001\008\000\149\001\009\000\149\001\
\\010\000\149\001\011\000\149\001\012\000\149\001\014\000\149\001\
\\016\000\149\001\020\000\149\001\030\000\149\001\031\000\149\001\
\\032\000\149\001\033\000\149\001\038\000\149\001\040\000\149\001\
\\042\000\149\001\000\000\
\\001\000\001\000\150\001\004\000\150\001\008\000\150\001\009\000\150\001\
\\010\000\150\001\011\000\150\001\012\000\150\001\014\000\150\001\
\\016\000\150\001\020\000\150\001\030\000\150\001\031\000\150\001\
\\032\000\150\001\033\000\150\001\038\000\150\001\040\000\150\001\
\\042\000\150\001\000\000\
\\001\000\001\000\151\001\004\000\151\001\008\000\151\001\009\000\151\001\
\\010\000\151\001\011\000\151\001\012\000\151\001\014\000\151\001\
\\016\000\151\001\020\000\151\001\030\000\151\001\031\000\151\001\
\\032\000\151\001\033\000\151\001\035\000\151\001\038\000\151\001\
\\040\000\151\001\042\000\151\001\044\000\151\001\045\000\151\001\
\\047\000\151\001\048\000\151\001\049\000\151\001\050\000\151\001\
\\051\000\151\001\052\000\151\001\053\000\151\001\054\000\151\001\
\\055\000\151\001\056\000\151\001\058\000\151\001\059\000\151\001\
\\060\000\151\001\061\000\151\001\062\000\151\001\063\000\151\001\
\\064\000\151\001\065\000\151\001\066\000\151\001\067\000\151\001\
\\068\000\151\001\000\000\
\\001\000\001\000\152\001\004\000\152\001\006\000\076\000\008\000\152\001\
\\009\000\152\001\010\000\152\001\011\000\152\001\012\000\152\001\
\\014\000\152\001\016\000\152\001\020\000\152\001\021\000\075\000\
\\022\000\009\000\023\000\074\000\025\000\102\000\029\000\072\000\
\\030\000\152\001\031\000\152\001\032\000\152\001\033\000\152\001\
\\034\000\071\000\038\000\152\001\040\000\152\001\042\000\152\001\000\000\
\\001\000\001\000\152\001\004\000\152\001\008\000\152\001\009\000\152\001\
\\010\000\152\001\011\000\152\001\012\000\152\001\014\000\152\001\
\\016\000\152\001\020\000\152\001\030\000\152\001\031\000\152\001\
\\032\000\152\001\033\000\152\001\038\000\152\001\040\000\152\001\
\\042\000\152\001\000\000\
\\001\000\001\000\153\001\004\000\153\001\008\000\153\001\009\000\153\001\
\\010\000\153\001\011\000\153\001\012\000\153\001\014\000\153\001\
\\016\000\153\001\020\000\153\001\030\000\153\001\031\000\153\001\
\\032\000\153\001\033\000\153\001\035\000\153\001\038\000\153\001\
\\040\000\153\001\042\000\153\001\044\000\153\001\045\000\153\001\
\\047\000\153\001\048\000\153\001\049\000\153\001\050\000\153\001\
\\051\000\153\001\052\000\153\001\053\000\153\001\054\000\153\001\
\\055\000\153\001\056\000\153\001\058\000\153\001\059\000\153\001\
\\060\000\153\001\061\000\153\001\062\000\153\001\063\000\153\001\
\\064\000\153\001\065\000\153\001\066\000\153\001\067\000\153\001\
\\068\000\153\001\000\000\
\\001\000\001\000\154\001\006\000\076\000\010\000\154\001\020\000\154\001\
\\021\000\075\000\022\000\009\000\023\000\074\000\025\000\102\000\
\\029\000\072\000\032\000\154\001\034\000\071\000\035\000\152\001\
\\044\000\152\001\045\000\152\001\047\000\152\001\048\000\152\001\
\\049\000\152\001\050\000\152\001\051\000\152\001\052\000\152\001\
\\053\000\152\001\054\000\152\001\055\000\152\001\056\000\152\001\
\\058\000\152\001\059\000\152\001\060\000\152\001\061\000\152\001\
\\062\000\152\001\063\000\152\001\064\000\152\001\065\000\152\001\
\\066\000\152\001\067\000\152\001\068\000\152\001\000\000\
\\001\000\001\000\155\001\004\000\155\001\010\000\155\001\012\000\155\001\
\\014\000\155\001\020\000\155\001\032\000\155\001\033\000\155\001\000\000\
\\001\000\001\000\156\001\004\000\156\001\010\000\156\001\012\000\156\001\
\\014\000\156\001\020\000\156\001\032\000\156\001\033\000\156\001\000\000\
\\001\000\001\000\157\001\004\000\157\001\008\000\157\001\009\000\157\001\
\\010\000\157\001\011\000\157\001\012\000\157\001\014\000\157\001\
\\016\000\157\001\020\000\157\001\030\000\157\001\031\000\157\001\
\\032\000\157\001\033\000\157\001\038\000\157\001\040\000\157\001\
\\042\000\157\001\000\000\
\\001\000\001\000\170\001\004\000\170\001\010\000\170\001\012\000\170\001\
\\014\000\170\001\020\000\170\001\032\000\170\001\033\000\170\001\000\000\
\\001\000\001\000\171\001\004\000\171\001\008\000\013\001\010\000\171\001\
\\012\000\171\001\014\000\171\001\020\000\171\001\032\000\171\001\
\\033\000\171\001\000\000\
\\001\000\001\000\172\001\004\000\172\001\008\000\172\001\009\000\172\001\
\\010\000\172\001\012\000\172\001\014\000\172\001\017\000\172\001\
\\020\000\172\001\031\000\172\001\032\000\172\001\033\000\172\001\000\000\
\\001\000\001\000\173\001\004\000\173\001\008\000\173\001\009\000\173\001\
\\010\000\173\001\012\000\173\001\014\000\173\001\017\000\173\001\
\\020\000\173\001\031\000\173\001\032\000\173\001\033\000\173\001\000\000\
\\001\000\001\000\174\001\004\000\174\001\008\000\174\001\009\000\174\001\
\\010\000\174\001\012\000\174\001\014\000\174\001\017\000\174\001\
\\020\000\174\001\031\000\174\001\032\000\174\001\033\000\174\001\000\000\
\\001\000\001\000\175\001\004\000\175\001\008\000\175\001\009\000\175\001\
\\010\000\175\001\012\000\175\001\014\000\175\001\017\000\175\001\
\\020\000\175\001\031\000\175\001\032\000\175\001\033\000\175\001\000\000\
\\001\000\001\000\176\001\004\000\176\001\008\000\176\001\009\000\176\001\
\\010\000\176\001\012\000\176\001\014\000\176\001\017\000\176\001\
\\020\000\176\001\031\000\176\001\032\000\176\001\033\000\176\001\000\000\
\\001\000\001\000\177\001\004\000\177\001\006\000\214\001\008\000\177\001\
\\009\000\177\001\010\000\177\001\012\000\177\001\014\000\177\001\
\\017\000\177\001\020\000\177\001\021\000\214\001\022\000\214\001\
\\023\000\214\001\025\000\214\001\029\000\214\001\031\000\177\001\
\\032\000\177\001\033\000\177\001\034\000\214\001\041\000\214\001\000\000\
\\001\000\001\000\177\001\004\000\177\001\008\000\177\001\009\000\177\001\
\\010\000\177\001\012\000\177\001\014\000\177\001\017\000\177\001\
\\020\000\177\001\031\000\177\001\032\000\177\001\033\000\177\001\000\000\
\\001\000\001\000\178\001\004\000\178\001\006\000\215\001\008\000\178\001\
\\009\000\178\001\010\000\178\001\012\000\178\001\013\000\098\000\
\\014\000\178\001\017\000\178\001\020\000\178\001\021\000\215\001\
\\022\000\215\001\023\000\215\001\025\000\215\001\029\000\215\001\
\\031\000\178\001\032\000\178\001\033\000\178\001\034\000\215\001\
\\041\000\215\001\000\000\
\\001\000\001\000\178\001\004\000\178\001\008\000\178\001\009\000\178\001\
\\010\000\178\001\012\000\178\001\013\000\098\000\014\000\178\001\
\\017\000\178\001\020\000\178\001\031\000\178\001\032\000\178\001\
\\033\000\178\001\000\000\
\\001\000\001\000\179\001\004\000\179\001\008\000\179\001\009\000\179\001\
\\010\000\179\001\012\000\179\001\014\000\179\001\017\000\179\001\
\\020\000\179\001\031\000\179\001\032\000\179\001\033\000\179\001\000\000\
\\001\000\001\000\180\001\010\000\180\001\020\000\224\000\032\000\180\001\000\000\
\\001\000\001\000\181\001\010\000\181\001\032\000\181\001\000\000\
\\001\000\001\000\182\001\006\000\076\000\010\000\182\001\021\000\075\000\
\\022\000\009\000\023\000\208\000\025\000\214\000\029\000\072\000\
\\032\000\182\001\034\000\071\000\041\000\206\000\000\000\
\\001\000\001\000\183\001\004\000\183\001\010\000\183\001\012\000\183\001\
\\014\000\183\001\020\000\183\001\032\000\183\001\033\000\183\001\000\000\
\\001\000\001\000\184\001\004\000\184\001\010\000\184\001\012\000\184\001\
\\014\000\184\001\020\000\184\001\032\000\184\001\033\000\184\001\000\000\
\\001\000\001\000\185\001\004\000\185\001\008\000\185\001\009\000\185\001\
\\010\000\185\001\012\000\185\001\014\000\185\001\017\000\185\001\
\\020\000\185\001\031\000\185\001\032\000\185\001\033\000\185\001\000\000\
\\001\000\001\000\190\001\004\000\190\001\008\000\190\001\009\000\190\001\
\\010\000\190\001\011\000\190\001\012\000\190\001\014\000\190\001\
\\016\000\190\001\017\000\190\001\020\000\190\001\030\000\190\001\
\\031\000\190\001\032\000\190\001\033\000\190\001\035\000\190\001\
\\038\000\190\001\040\000\190\001\042\000\190\001\044\000\190\001\
\\045\000\190\001\047\000\190\001\048\000\190\001\049\000\190\001\
\\050\000\190\001\051\000\190\001\052\000\190\001\053\000\190\001\
\\054\000\190\001\055\000\190\001\056\000\190\001\058\000\190\001\
\\059\000\190\001\060\000\190\001\061\000\190\001\062\000\190\001\
\\063\000\190\001\064\000\190\001\065\000\190\001\066\000\190\001\
\\067\000\190\001\068\000\190\001\000\000\
\\001\000\001\000\191\001\004\000\191\001\008\000\191\001\009\000\191\001\
\\010\000\191\001\011\000\191\001\012\000\191\001\014\000\191\001\
\\016\000\191\001\017\000\191\001\020\000\191\001\030\000\191\001\
\\031\000\191\001\032\000\191\001\033\000\191\001\035\000\191\001\
\\038\000\191\001\040\000\191\001\042\000\191\001\044\000\191\001\
\\045\000\191\001\047\000\191\001\048\000\191\001\049\000\191\001\
\\050\000\191\001\051\000\191\001\052\000\191\001\053\000\191\001\
\\054\000\191\001\055\000\191\001\056\000\191\001\058\000\191\001\
\\059\000\191\001\060\000\191\001\061\000\191\001\062\000\191\001\
\\063\000\191\001\064\000\191\001\065\000\191\001\066\000\191\001\
\\067\000\191\001\068\000\191\001\000\000\
\\001\000\001\000\192\001\004\000\192\001\008\000\192\001\009\000\192\001\
\\010\000\192\001\011\000\192\001\012\000\192\001\014\000\192\001\
\\016\000\192\001\017\000\192\001\020\000\192\001\030\000\192\001\
\\031\000\192\001\032\000\192\001\033\000\192\001\035\000\192\001\
\\038\000\192\001\040\000\192\001\042\000\192\001\044\000\192\001\
\\045\000\192\001\047\000\192\001\048\000\192\001\049\000\192\001\
\\050\000\192\001\051\000\192\001\052\000\192\001\053\000\192\001\
\\054\000\192\001\055\000\192\001\056\000\192\001\058\000\192\001\
\\059\000\192\001\060\000\192\001\061\000\192\001\062\000\192\001\
\\063\000\192\001\064\000\192\001\065\000\192\001\066\000\192\001\
\\067\000\192\001\068\000\192\001\000\000\
\\001\000\001\000\193\001\004\000\193\001\008\000\193\001\009\000\193\001\
\\010\000\193\001\011\000\193\001\012\000\193\001\014\000\193\001\
\\016\000\193\001\017\000\193\001\020\000\193\001\030\000\193\001\
\\031\000\193\001\032\000\193\001\033\000\193\001\035\000\193\001\
\\038\000\193\001\040\000\193\001\042\000\193\001\044\000\193\001\
\\045\000\193\001\047\000\193\001\048\000\193\001\049\000\193\001\
\\050\000\193\001\051\000\193\001\052\000\193\001\053\000\193\001\
\\054\000\193\001\055\000\193\001\056\000\193\001\058\000\193\001\
\\059\000\193\001\060\000\193\001\061\000\193\001\062\000\193\001\
\\063\000\193\001\064\000\193\001\065\000\193\001\066\000\193\001\
\\067\000\193\001\068\000\193\001\000\000\
\\001\000\001\000\213\001\002\000\213\001\004\000\213\001\005\000\213\001\
\\006\000\213\001\008\000\213\001\009\000\213\001\010\000\213\001\
\\011\000\213\001\012\000\213\001\014\000\213\001\016\000\213\001\
\\017\000\213\001\018\000\213\001\020\000\213\001\021\000\213\001\
\\022\000\213\001\023\000\213\001\025\000\213\001\029\000\213\001\
\\030\000\213\001\031\000\213\001\032\000\213\001\033\000\213\001\
\\034\000\213\001\035\000\213\001\038\000\213\001\040\000\213\001\
\\041\000\213\001\042\000\213\001\043\000\213\001\044\000\213\001\
\\045\000\213\001\047\000\213\001\048\000\213\001\049\000\213\001\
\\050\000\213\001\051\000\213\001\052\000\213\001\053\000\213\001\
\\054\000\213\001\055\000\213\001\056\000\213\001\058\000\213\001\
\\059\000\213\001\060\000\213\001\061\000\213\001\062\000\213\001\
\\063\000\213\001\064\000\213\001\065\000\213\001\066\000\213\001\
\\067\000\213\001\068\000\213\001\000\000\
\\001\000\001\000\214\001\002\000\214\001\004\000\214\001\005\000\214\001\
\\006\000\214\001\008\000\214\001\009\000\214\001\010\000\214\001\
\\011\000\214\001\012\000\214\001\014\000\214\001\016\000\214\001\
\\017\000\214\001\018\000\214\001\020\000\214\001\021\000\214\001\
\\022\000\214\001\023\000\214\001\025\000\214\001\029\000\214\001\
\\030\000\214\001\031\000\214\001\032\000\214\001\033\000\214\001\
\\034\000\214\001\035\000\214\001\038\000\214\001\040\000\214\001\
\\042\000\214\001\043\000\214\001\044\000\214\001\045\000\214\001\
\\047\000\214\001\048\000\214\001\049\000\214\001\050\000\214\001\
\\051\000\214\001\052\000\214\001\053\000\214\001\054\000\214\001\
\\055\000\214\001\056\000\214\001\058\000\214\001\059\000\214\001\
\\060\000\214\001\061\000\214\001\062\000\214\001\063\000\214\001\
\\064\000\214\001\065\000\214\001\066\000\214\001\067\000\214\001\
\\068\000\214\001\000\000\
\\001\000\001\000\215\001\002\000\215\001\004\000\215\001\005\000\215\001\
\\006\000\215\001\008\000\215\001\009\000\215\001\010\000\215\001\
\\011\000\215\001\012\000\215\001\013\000\098\000\014\000\215\001\
\\016\000\215\001\017\000\215\001\018\000\215\001\020\000\215\001\
\\021\000\215\001\022\000\215\001\023\000\215\001\025\000\215\001\
\\029\000\215\001\030\000\215\001\031\000\215\001\032\000\215\001\
\\033\000\215\001\034\000\215\001\035\000\215\001\038\000\215\001\
\\040\000\215\001\042\000\215\001\043\000\215\001\000\000\
\\001\000\001\000\215\001\006\000\215\001\010\000\215\001\013\000\098\000\
\\017\000\162\000\020\000\215\001\021\000\215\001\022\000\215\001\
\\023\000\215\001\025\000\215\001\029\000\215\001\032\000\215\001\
\\034\000\215\001\035\000\215\001\044\000\215\001\045\000\215\001\
\\047\000\215\001\048\000\215\001\049\000\215\001\050\000\215\001\
\\051\000\215\001\052\000\215\001\053\000\215\001\054\000\215\001\
\\055\000\215\001\056\000\215\001\058\000\215\001\059\000\215\001\
\\060\000\215\001\061\000\215\001\062\000\215\001\063\000\215\001\
\\064\000\215\001\065\000\215\001\066\000\215\001\067\000\215\001\
\\068\000\215\001\000\000\
\\001\000\001\000\216\001\002\000\216\001\003\000\216\001\004\000\216\001\
\\005\000\216\001\006\000\216\001\007\000\216\001\008\000\216\001\
\\009\000\216\001\010\000\216\001\011\000\216\001\012\000\216\001\
\\013\000\216\001\014\000\216\001\016\000\216\001\017\000\216\001\
\\018\000\216\001\020\000\216\001\021\000\216\001\022\000\216\001\
\\023\000\216\001\025\000\216\001\028\000\216\001\029\000\216\001\
\\030\000\216\001\031\000\216\001\032\000\216\001\033\000\216\001\
\\034\000\216\001\035\000\216\001\038\000\216\001\040\000\216\001\
\\041\000\216\001\042\000\216\001\043\000\216\001\044\000\216\001\
\\045\000\216\001\047\000\216\001\048\000\216\001\049\000\216\001\
\\050\000\216\001\051\000\216\001\052\000\216\001\053\000\216\001\
\\054\000\216\001\055\000\216\001\056\000\216\001\058\000\216\001\
\\059\000\216\001\060\000\216\001\061\000\216\001\062\000\216\001\
\\063\000\216\001\064\000\216\001\065\000\216\001\066\000\216\001\
\\067\000\216\001\068\000\216\001\000\000\
\\001\000\001\000\191\000\010\000\106\001\032\000\106\001\000\000\
\\001\000\002\000\080\001\011\000\080\001\016\000\080\001\030\000\080\001\
\\038\000\080\001\040\000\080\001\042\000\080\001\000\000\
\\001\000\002\000\087\001\011\000\087\001\014\000\087\001\016\000\087\001\
\\018\000\087\001\030\000\087\001\038\000\087\001\040\000\087\001\
\\042\000\087\001\000\000\
\\001\000\002\000\090\001\011\000\090\001\014\000\090\001\016\000\090\001\
\\018\000\090\001\030\000\090\001\038\000\090\001\040\000\090\001\
\\042\000\090\001\043\000\090\001\000\000\
\\001\000\002\000\091\001\011\000\091\001\014\000\091\001\016\000\091\001\
\\018\000\091\001\030\000\091\001\038\000\091\001\040\000\091\001\
\\042\000\091\001\043\000\091\001\000\000\
\\001\000\002\000\092\001\005\000\156\000\011\000\092\001\014\000\092\001\
\\016\000\092\001\018\000\092\001\030\000\092\001\038\000\092\001\
\\040\000\092\001\042\000\092\001\043\000\092\001\000\000\
\\001\000\002\000\093\001\005\000\093\001\011\000\093\001\014\000\093\001\
\\016\000\093\001\018\000\093\001\028\000\155\000\030\000\093\001\
\\038\000\093\001\040\000\093\001\042\000\093\001\043\000\093\001\000\000\
\\001\000\002\000\094\001\005\000\094\001\011\000\094\001\014\000\094\001\
\\016\000\094\001\018\000\094\001\030\000\094\001\038\000\094\001\
\\040\000\094\001\042\000\094\001\043\000\094\001\000\000\
\\001\000\002\000\194\001\009\000\194\001\011\000\194\001\014\000\194\001\
\\016\000\194\001\017\000\194\001\018\000\194\001\030\000\194\001\
\\032\000\194\001\038\000\194\001\040\000\194\001\042\000\194\001\000\000\
\\001\000\002\000\195\001\009\000\195\001\011\000\195\001\014\000\195\001\
\\016\000\195\001\017\000\195\001\018\000\195\001\020\000\207\001\
\\030\000\195\001\032\000\195\001\038\000\195\001\040\000\195\001\
\\042\000\195\001\000\000\
\\001\000\002\000\196\001\005\000\196\001\009\000\196\001\011\000\196\001\
\\014\000\196\001\016\000\196\001\017\000\196\001\018\000\196\001\
\\020\000\196\001\030\000\196\001\032\000\196\001\038\000\196\001\
\\040\000\196\001\042\000\196\001\043\000\196\001\000\000\
\\001\000\002\000\197\001\005\000\197\001\009\000\197\001\011\000\197\001\
\\014\000\197\001\016\000\197\001\017\000\197\001\018\000\197\001\
\\020\000\197\001\022\000\009\000\030\000\197\001\032\000\197\001\
\\035\000\117\000\038\000\197\001\040\000\197\001\042\000\197\001\
\\043\000\197\001\000\000\
\\001\000\002\000\198\001\005\000\198\001\009\000\198\001\011\000\198\001\
\\014\000\198\001\016\000\198\001\017\000\198\001\018\000\198\001\
\\020\000\198\001\022\000\198\001\030\000\198\001\032\000\198\001\
\\035\000\198\001\038\000\198\001\040\000\198\001\042\000\198\001\
\\043\000\198\001\000\000\
\\001\000\002\000\199\001\005\000\199\001\009\000\199\001\011\000\199\001\
\\014\000\199\001\016\000\199\001\017\000\199\001\018\000\199\001\
\\020\000\199\001\022\000\199\001\030\000\199\001\032\000\199\001\
\\035\000\199\001\038\000\199\001\040\000\199\001\042\000\199\001\
\\043\000\199\001\000\000\
\\001\000\002\000\200\001\005\000\200\001\009\000\200\001\011\000\200\001\
\\014\000\200\001\016\000\200\001\017\000\200\001\018\000\200\001\
\\020\000\200\001\022\000\200\001\030\000\200\001\032\000\200\001\
\\035\000\200\001\038\000\200\001\040\000\200\001\042\000\200\001\
\\043\000\200\001\000\000\
\\001\000\002\000\201\001\005\000\201\001\009\000\201\001\011\000\201\001\
\\014\000\201\001\016\000\201\001\017\000\201\001\018\000\201\001\
\\020\000\201\001\022\000\201\001\030\000\201\001\032\000\201\001\
\\035\000\201\001\038\000\201\001\040\000\201\001\042\000\201\001\
\\043\000\201\001\000\000\
\\001\000\002\000\202\001\005\000\202\001\009\000\202\001\011\000\202\001\
\\014\000\202\001\016\000\202\001\017\000\202\001\018\000\202\001\
\\020\000\202\001\022\000\202\001\030\000\202\001\032\000\202\001\
\\035\000\202\001\038\000\202\001\040\000\202\001\042\000\202\001\
\\043\000\202\001\000\000\
\\001\000\002\000\205\001\009\000\205\001\011\000\205\001\014\000\205\001\
\\016\000\205\001\017\000\205\001\018\000\205\001\020\000\205\001\
\\030\000\205\001\032\000\205\001\038\000\205\001\040\000\205\001\
\\042\000\205\001\000\000\
\\001\000\002\000\206\001\009\000\206\001\011\000\206\001\014\000\206\001\
\\016\000\206\001\017\000\206\001\018\000\206\001\020\000\206\001\
\\022\000\009\000\030\000\206\001\032\000\206\001\038\000\206\001\
\\040\000\206\001\042\000\206\001\000\000\
\\001\000\002\000\207\001\009\000\207\001\011\000\207\001\014\000\207\001\
\\016\000\207\001\017\000\207\001\018\000\207\001\030\000\207\001\
\\032\000\207\001\038\000\207\001\040\000\207\001\042\000\207\001\000\000\
\\001\000\002\000\217\001\005\000\217\001\009\000\217\001\011\000\217\001\
\\014\000\217\001\016\000\217\001\017\000\217\001\018\000\217\001\
\\020\000\217\001\022\000\217\001\030\000\217\001\032\000\217\001\
\\035\000\217\001\038\000\217\001\040\000\217\001\042\000\217\001\
\\043\000\217\001\000\000\
\\001\000\002\000\044\000\011\000\086\001\014\000\086\001\016\000\086\001\
\\018\000\086\001\030\000\086\001\038\000\086\001\040\000\086\001\
\\042\000\086\001\000\000\
\\001\000\002\000\049\000\011\000\079\001\016\000\079\001\030\000\079\001\
\\038\000\079\001\040\000\079\001\042\000\079\001\000\000\
\\001\000\002\000\051\000\011\000\089\001\014\000\089\001\016\000\089\001\
\\018\000\089\001\030\000\089\001\038\000\089\001\040\000\089\001\
\\042\000\089\001\043\000\089\001\000\000\
\\001\000\003\000\255\000\006\000\215\001\008\000\178\001\009\000\178\001\
\\013\000\098\000\017\000\178\001\021\000\215\001\022\000\215\001\
\\023\000\215\001\025\000\215\001\029\000\215\001\031\000\178\001\
\\032\000\178\001\034\000\215\001\041\000\215\001\000\000\
\\001\000\004\000\099\001\012\000\099\001\014\000\099\001\033\000\099\001\000\000\
\\001\000\004\000\100\001\012\000\100\001\014\000\100\001\033\000\100\001\000\000\
\\001\000\004\000\101\001\012\000\101\001\014\000\101\001\020\000\012\001\
\\033\000\101\001\000\000\
\\001\000\004\000\102\001\012\000\102\001\014\000\102\001\033\000\102\001\000\000\
\\001\000\004\000\103\001\012\000\103\001\014\000\103\001\033\000\103\001\000\000\
\\001\000\004\000\154\001\006\000\076\000\012\000\154\001\014\000\154\001\
\\019\000\051\001\021\000\075\000\022\000\009\000\023\000\074\000\
\\025\000\102\000\029\000\072\000\033\000\154\001\034\000\071\000\000\000\
\\001\000\004\000\182\001\006\000\076\000\012\000\182\001\014\000\182\001\
\\020\000\182\001\021\000\075\000\022\000\009\000\023\000\208\000\
\\025\000\214\000\029\000\072\000\033\000\182\001\034\000\071\000\
\\041\000\206\000\000\000\
\\001\000\004\000\114\000\012\000\097\001\014\000\097\001\033\000\113\000\000\000\
\\001\000\004\000\114\000\033\000\113\000\000\000\
\\001\000\006\000\076\000\010\000\104\001\021\000\075\000\022\000\009\000\
\\023\000\074\000\024\000\146\000\025\000\145\000\027\000\144\000\
\\029\000\072\000\034\000\071\000\046\000\143\000\057\000\142\000\000\000\
\\001\000\006\000\076\000\021\000\075\000\022\000\009\000\023\000\074\000\
\\024\000\146\000\025\000\145\000\027\000\144\000\029\000\072\000\
\\034\000\071\000\046\000\143\000\057\000\142\000\000\000\
\\001\000\006\000\076\000\021\000\075\000\022\000\009\000\023\000\074\000\
\\025\000\073\000\029\000\072\000\031\000\158\001\034\000\071\000\000\000\
\\001\000\006\000\076\000\021\000\075\000\022\000\009\000\023\000\074\000\
\\025\000\073\000\029\000\072\000\032\000\158\001\034\000\071\000\000\000\
\\001\000\006\000\076\000\021\000\075\000\022\000\009\000\023\000\074\000\
\\025\000\073\000\029\000\072\000\032\000\105\000\034\000\071\000\000\000\
\\001\000\006\000\076\000\021\000\075\000\022\000\009\000\023\000\074\000\
\\025\000\073\000\029\000\072\000\034\000\071\000\000\000\
\\001\000\006\000\076\000\021\000\075\000\022\000\009\000\023\000\074\000\
\\029\000\072\000\034\000\071\000\000\000\
\\001\000\006\000\076\000\021\000\075\000\022\000\009\000\023\000\208\000\
\\025\000\207\000\029\000\072\000\031\000\186\001\034\000\071\000\
\\041\000\206\000\000\000\
\\001\000\006\000\076\000\021\000\075\000\022\000\009\000\023\000\208\000\
\\025\000\207\000\029\000\072\000\032\000\186\001\034\000\071\000\
\\041\000\206\000\000\000\
\\001\000\006\000\076\000\021\000\075\000\022\000\009\000\023\000\208\000\
\\025\000\207\000\029\000\072\000\032\000\007\001\034\000\071\000\
\\041\000\206\000\000\000\
\\001\000\006\000\076\000\021\000\075\000\022\000\009\000\023\000\208\000\
\\025\000\207\000\029\000\072\000\034\000\071\000\041\000\206\000\000\000\
\\001\000\006\000\076\000\021\000\075\000\022\000\009\000\023\000\208\000\
\\025\000\214\000\029\000\072\000\034\000\071\000\041\000\206\000\000\000\
\\001\000\006\000\076\000\021\000\075\000\022\000\009\000\023\000\208\000\
\\029\000\072\000\034\000\071\000\041\000\206\000\000\000\
\\001\000\007\000\017\000\000\000\
\\001\000\007\000\048\000\017\000\082\001\000\000\
\\001\000\007\000\093\000\000\000\
\\001\000\007\000\095\000\000\000\
\\001\000\008\000\166\001\009\000\166\001\017\000\166\001\031\000\166\001\
\\032\000\166\001\000\000\
\\001\000\008\000\167\001\009\000\167\001\017\000\167\001\031\000\167\001\
\\032\000\167\001\000\000\
\\001\000\008\000\168\001\009\000\168\001\017\000\168\001\031\000\168\001\
\\032\000\168\001\000\000\
\\001\000\008\000\169\001\009\000\169\001\017\000\169\001\031\000\169\001\
\\032\000\169\001\000\000\
\\001\000\008\000\004\001\009\000\165\001\017\000\165\001\031\000\165\001\
\\032\000\165\001\000\000\
\\001\000\009\000\162\001\017\000\162\001\031\000\162\001\032\000\162\001\000\000\
\\001\000\009\000\163\001\017\000\163\001\031\000\163\001\032\000\163\001\000\000\
\\001\000\009\000\164\001\017\000\164\001\031\000\164\001\032\000\164\001\000\000\
\\001\000\009\000\079\000\032\000\212\001\000\000\
\\001\000\009\000\130\000\032\000\129\000\000\000\
\\001\000\009\000\132\000\031\000\160\001\032\000\160\001\000\000\
\\001\000\009\000\154\000\032\000\204\001\000\000\
\\001\000\009\000\154\000\032\000\153\000\000\000\
\\001\000\009\000\047\001\032\000\046\001\000\000\
\\001\000\009\000\049\001\031\000\188\001\032\000\188\001\000\000\
\\001\000\010\000\105\001\000\000\
\\001\000\010\000\107\001\032\000\107\001\000\000\
\\001\000\010\000\192\000\000\000\
\\001\000\011\000\000\000\015\000\000\000\016\000\000\000\018\000\000\000\
\\030\000\000\000\038\000\000\000\040\000\000\000\042\000\000\000\000\000\
\\001\000\011\000\059\001\015\000\059\001\016\000\059\001\018\000\059\001\
\\030\000\059\001\038\000\059\001\040\000\059\001\042\000\059\001\000\000\
\\001\000\011\000\060\001\015\000\060\001\016\000\060\001\018\000\060\001\
\\030\000\060\001\038\000\060\001\040\000\060\001\042\000\060\001\000\000\
\\001\000\011\000\061\001\015\000\061\001\016\000\061\001\018\000\061\001\
\\030\000\061\001\038\000\061\001\040\000\061\001\042\000\061\001\000\000\
\\001\000\011\000\064\001\014\000\064\001\018\000\064\001\030\000\064\001\
\\038\000\064\001\040\000\064\001\042\000\064\001\000\000\
\\001\000\011\000\065\001\014\000\065\001\017\000\077\000\018\000\065\001\
\\030\000\065\001\038\000\065\001\040\000\065\001\042\000\065\001\000\000\
\\001\000\011\000\066\001\014\000\066\001\018\000\066\001\030\000\066\001\
\\038\000\066\001\040\000\066\001\042\000\066\001\000\000\
\\001\000\011\000\067\001\014\000\067\001\018\000\067\001\030\000\067\001\
\\038\000\067\001\040\000\067\001\042\000\067\001\000\000\
\\001\000\011\000\068\001\014\000\068\001\018\000\068\001\030\000\068\001\
\\038\000\068\001\040\000\068\001\042\000\068\001\000\000\
\\001\000\011\000\069\001\014\000\069\001\018\000\069\001\030\000\069\001\
\\038\000\069\001\040\000\069\001\042\000\069\001\000\000\
\\001\000\011\000\070\001\014\000\070\001\018\000\070\001\030\000\070\001\
\\038\000\070\001\040\000\070\001\042\000\070\001\000\000\
\\001\000\011\000\073\001\016\000\073\001\030\000\073\001\038\000\073\001\
\\040\000\073\001\042\000\073\001\000\000\
\\001\000\011\000\074\001\016\000\074\001\030\000\074\001\038\000\074\001\
\\040\000\074\001\042\000\074\001\000\000\
\\001\000\011\000\075\001\016\000\075\001\030\000\075\001\038\000\075\001\
\\040\000\075\001\042\000\075\001\000\000\
\\001\000\011\000\076\001\016\000\076\001\030\000\076\001\038\000\076\001\
\\040\000\076\001\042\000\076\001\000\000\
\\001\000\011\000\077\001\016\000\077\001\030\000\077\001\038\000\077\001\
\\040\000\077\001\042\000\077\001\000\000\
\\001\000\011\000\078\001\016\000\078\001\030\000\078\001\038\000\078\001\
\\040\000\078\001\042\000\078\001\000\000\
\\001\000\011\000\083\001\014\000\083\001\018\000\083\001\030\000\083\001\
\\038\000\083\001\040\000\083\001\042\000\083\001\043\000\053\000\000\000\
\\001\000\011\000\083\001\016\000\083\001\030\000\083\001\038\000\083\001\
\\040\000\083\001\042\000\083\001\043\000\053\000\000\000\
\\001\000\011\000\084\001\014\000\084\001\016\000\084\001\018\000\084\001\
\\030\000\084\001\038\000\084\001\040\000\084\001\042\000\084\001\000\000\
\\001\000\011\000\085\001\014\000\085\001\016\000\085\001\018\000\085\001\
\\030\000\085\001\038\000\085\001\040\000\085\001\042\000\085\001\000\000\
\\001\000\011\000\088\001\014\000\088\001\016\000\088\001\018\000\088\001\
\\030\000\088\001\038\000\088\001\040\000\088\001\042\000\088\001\
\\043\000\088\001\000\000\
\\001\000\011\000\016\000\016\000\071\001\030\000\015\000\038\000\014\000\
\\040\000\013\000\042\000\012\000\000\000\
\\001\000\011\000\041\000\014\000\062\001\018\000\040\000\030\000\039\000\
\\038\000\038\000\040\000\037\000\042\000\036\000\000\000\
\\001\000\012\000\098\001\014\000\098\001\000\000\
\\001\000\012\000\135\000\014\000\095\001\000\000\
\\001\000\014\000\063\001\000\000\
\\001\000\014\000\096\001\000\000\
\\001\000\014\000\055\000\000\000\
\\001\000\014\000\160\000\000\000\
\\001\000\016\000\072\001\000\000\
\\001\000\016\000\019\000\000\000\
\\001\000\017\000\081\001\000\000\
\\001\000\017\000\042\000\000\000\
\\001\000\017\000\077\000\000\000\
\\001\000\017\000\081\000\000\000\
\\001\000\017\000\090\000\000\000\
\\001\000\017\000\005\001\000\000\
\\001\000\020\000\115\000\000\000\
\\001\000\022\000\208\001\025\000\027\000\039\000\026\000\000\000\
\\001\000\022\000\209\001\000\000\
\\001\000\022\000\210\001\000\000\
\\001\000\022\000\009\000\000\000\
\\001\000\022\000\009\000\025\000\088\000\032\000\120\000\039\000\026\000\000\000\
\\001\000\022\000\009\000\025\000\088\000\039\000\026\000\000\000\
\\001\000\022\000\009\000\025\000\151\000\039\000\026\000\000\000\
\\001\000\026\000\006\000\000\000\
\\001\000\031\000\159\001\032\000\159\001\000\000\
\\001\000\031\000\161\001\032\000\161\001\000\000\
\\001\000\031\000\187\001\032\000\187\001\000\000\
\\001\000\031\000\189\001\032\000\189\001\000\000\
\\001\000\031\000\131\000\000\000\
\\001\000\031\000\048\001\000\000\
\\001\000\032\000\203\001\000\000\
\\001\000\032\000\211\001\000\000\
\\001\000\032\000\080\000\000\000\
\\001\000\032\000\152\000\000\000\
\\001\000\032\000\157\000\000\000\
\\001\000\032\000\221\000\000\000\
\\001\000\032\000\254\000\000\000\
\\001\000\032\000\015\001\000\000\
\\001\000\032\000\053\001\000\000\
\\001\000\032\000\057\001\000\000\
\\001\000\034\000\020\000\000\000\
\\001\000\034\000\056\000\000\000\
\\001\000\035\000\190\000\044\000\189\000\045\000\188\000\047\000\187\000\
\\048\000\186\000\049\000\185\000\050\000\184\000\051\000\183\000\
\\052\000\182\000\053\000\181\000\054\000\180\000\055\000\179\000\
\\056\000\178\000\058\000\177\000\059\000\176\000\060\000\175\000\
\\061\000\174\000\062\000\173\000\063\000\172\000\064\000\171\000\
\\065\000\170\000\066\000\169\000\067\000\168\000\068\000\167\000\000\000\
\\001\000\036\000\004\000\037\000\003\000\000\000\
\\001\000\039\000\026\000\000\000\
\"
val actionRowNumbers =
"\212\000\192\000\192\000\148\000\
\\188\000\168\000\124\000\076\000\
\\168\000\177\000\209\000\188\000\
\\185\000\188\000\185\000\169\000\
\\176\000\147\000\157\000\179\000\
\\186\000\188\000\098\000\158\000\
\\097\000\213\000\125\000\161\000\
\\099\000\188\000\100\000\164\000\
\\169\000\174\000\210\000\188\000\
\\185\000\188\000\185\000\185\000\
\\116\000\180\000\185\000\136\000\
\\201\000\181\000\190\000\188\000\
\\182\000\185\000\159\000\185\000\
\\172\000\149\000\150\000\126\000\
\\188\000\153\000\127\000\188\000\
\\163\000\074\000\043\000\073\000\
\\042\000\041\000\036\000\032\000\
\\160\000\071\000\070\000\115\000\
\\113\000\069\000\068\000\190\000\
\\166\000\213\000\187\000\110\000\
\\092\000\093\000\184\000\088\000\
\\086\000\178\000\189\000\162\000\
\\188\000\167\000\165\000\190\000\
\\151\000\190\000\152\000\154\000\
\\188\000\044\000\039\000\040\000\
\\114\000\116\000\137\000\033\000\
\\193\000\197\000\138\000\079\000\
\\200\000\109\000\171\000\111\000\
\\188\000\190\000\089\000\191\000\
\\202\000\140\000\094\000\083\000\
\\082\000\080\000\155\000\156\000\
\\072\000\203\000\031\000\034\000\
\\116\000\045\000\116\000\170\000\
\\175\000\110\000\075\000\046\000\
\\211\000\077\000\143\000\145\000\
\\117\000\117\000\112\000\112\000\
\\121\000\108\000\085\000\096\000\
\\087\000\190\000\095\000\091\000\
\\190\000\191\000\188\000\049\000\
\\204\000\194\000\078\000\173\000\
\\116\000\048\000\062\000\038\000\
\\047\000\117\000\117\000\117\000\
\\117\000\117\000\117\000\117\000\
\\117\000\117\000\117\000\117\000\
\\117\000\117\000\117\000\117\000\
\\117\000\117\000\117\000\117\000\
\\117\000\117\000\117\000\117\000\
\\117\000\112\000\188\000\062\000\
\\062\000\029\000\205\000\101\000\
\\122\000\057\000\056\000\054\000\
\\131\000\132\000\134\000\183\000\
\\055\000\120\000\118\000\059\000\
\\066\000\104\000\051\000\065\000\
\\119\000\206\000\090\000\199\000\
\\139\000\084\000\081\000\035\000\
\\027\000\000\000\064\000\117\000\
\\062\000\062\000\062\000\062\000\
\\062\000\062\000\062\000\062\000\
\\062\000\062\000\062\000\062\000\
\\062\000\062\000\062\000\062\000\
\\062\000\062\000\062\000\062\000\
\\062\000\062\000\062\000\062\000\
\\144\000\108\000\015\000\003\000\
\\030\000\121\000\060\000\058\000\
\\052\000\053\000\121\000\116\000\
\\141\000\128\000\195\000\198\000\
\\142\000\103\000\107\000\123\000\
\\207\000\188\000\063\000\037\000\
\\026\000\025\000\024\000\023\000\
\\022\000\021\000\020\000\019\000\
\\018\000\017\000\016\000\014\000\
\\013\000\012\000\011\000\010\000\
\\009\000\008\000\007\000\006\000\
\\005\000\002\000\001\000\004\000\
\\104\000\133\000\135\000\028\000\
\\129\000\121\000\061\000\121\000\
\\105\000\106\000\050\000\067\000\
\\102\000\208\000\196\000\130\000\
\\146\000"
val gotoT =
"\
\\001\000\056\001\000\000\
\\002\000\003\000\000\000\
\\002\000\005\000\000\000\
\\000\000\
\\054\000\006\000\000\000\
\\005\000\009\000\006\000\008\000\000\000\
\\000\000\
\\000\000\
\\005\000\016\000\006\000\008\000\000\000\
\\000\000\
\\000\000\
\\054\000\019\000\000\000\
\\011\000\023\000\012\000\022\000\050\000\021\000\055\000\020\000\000\000\
\\007\000\028\000\008\000\027\000\054\000\026\000\000\000\
\\013\000\031\000\014\000\030\000\050\000\029\000\055\000\020\000\000\000\
\\003\000\033\000\004\000\032\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\054\000\041\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\051\000\044\000\055\000\043\000\000\000\
\\009\000\045\000\000\000\
\\000\000\
\\000\000\
\\054\000\048\000\000\000\
\\000\000\
\\010\000\050\000\000\000\
\\003\000\052\000\004\000\032\000\000\000\
\\000\000\
\\000\000\
\\054\000\055\000\000\000\
\\011\000\057\000\012\000\022\000\050\000\056\000\055\000\020\000\000\000\
\\054\000\058\000\000\000\
\\050\000\059\000\055\000\020\000\000\000\
\\013\000\060\000\014\000\030\000\050\000\029\000\055\000\020\000\000\000\
\\024\000\068\000\025\000\067\000\027\000\066\000\028\000\065\000\
\\044\000\064\000\052\000\063\000\053\000\062\000\054\000\061\000\000\000\
\\000\000\
\\011\000\076\000\012\000\022\000\050\000\021\000\055\000\020\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\045\000\085\000\046\000\084\000\047\000\083\000\049\000\082\000\
\\052\000\063\000\053\000\081\000\054\000\061\000\055\000\080\000\000\000\
\\007\000\028\000\008\000\087\000\054\000\026\000\000\000\
\\000\000\
\\013\000\089\000\014\000\030\000\050\000\029\000\055\000\020\000\000\000\
\\000\000\
\\011\000\090\000\012\000\022\000\050\000\021\000\055\000\020\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\054\000\092\000\000\000\
\\000\000\
\\000\000\
\\054\000\094\000\000\000\
\\010\000\095\000\000\000\
\\000\000\
\\028\000\099\000\030\000\098\000\044\000\064\000\052\000\063\000\
\\053\000\097\000\054\000\061\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\024\000\102\000\025\000\067\000\027\000\066\000\028\000\065\000\
\\044\000\064\000\052\000\063\000\053\000\062\000\054\000\061\000\000\000\
\\024\000\106\000\025\000\067\000\027\000\066\000\028\000\065\000\
\\031\000\105\000\032\000\104\000\044\000\064\000\052\000\063\000\
\\053\000\062\000\054\000\061\000\000\000\
\\000\000\
\\000\000\
\\045\000\107\000\046\000\084\000\047\000\083\000\049\000\082\000\
\\052\000\063\000\053\000\081\000\054\000\061\000\055\000\080\000\000\000\
\\000\000\
\\051\000\108\000\055\000\043\000\000\000\
\\000\000\
\\018\000\110\000\019\000\109\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\052\000\063\000\053\000\114\000\054\000\061\000\000\000\
\\000\000\
\\000\000\
\\045\000\117\000\046\000\084\000\047\000\083\000\048\000\116\000\
\\049\000\082\000\052\000\063\000\053\000\081\000\054\000\061\000\
\\055\000\080\000\000\000\
\\000\000\
\\015\000\121\000\016\000\120\000\054\000\119\000\000\000\
\\000\000\
\\000\000\
\\045\000\122\000\046\000\084\000\047\000\083\000\049\000\082\000\
\\052\000\063\000\053\000\081\000\054\000\061\000\055\000\080\000\000\000\
\\000\000\
\\045\000\123\000\046\000\084\000\047\000\083\000\049\000\082\000\
\\052\000\063\000\053\000\081\000\054\000\061\000\055\000\080\000\000\000\
\\000\000\
\\000\000\
\\054\000\124\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\024\000\106\000\025\000\067\000\027\000\066\000\028\000\065\000\
\\031\000\125\000\032\000\104\000\044\000\064\000\052\000\063\000\
\\053\000\062\000\054\000\061\000\000\000\
\\024\000\126\000\025\000\067\000\027\000\066\000\028\000\065\000\
\\044\000\064\000\052\000\063\000\053\000\062\000\054\000\061\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\018\000\131\000\019\000\109\000\000\000\
\\017\000\132\000\000\000\
\\021\000\139\000\022\000\138\000\023\000\137\000\028\000\136\000\
\\044\000\064\000\052\000\063\000\053\000\135\000\054\000\134\000\000\000\
\\054\000\145\000\000\000\
\\046\000\147\000\047\000\083\000\049\000\146\000\052\000\063\000\
\\053\000\081\000\054\000\061\000\055\000\080\000\000\000\
\\000\000\
\\046\000\148\000\047\000\083\000\052\000\063\000\053\000\081\000\
\\054\000\061\000\055\000\080\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\024\000\106\000\025\000\067\000\027\000\066\000\028\000\065\000\
\\032\000\156\000\044\000\064\000\052\000\063\000\053\000\062\000\
\\054\000\061\000\000\000\
\\000\000\
\\024\000\106\000\025\000\067\000\027\000\066\000\028\000\065\000\
\\032\000\157\000\044\000\064\000\052\000\063\000\053\000\062\000\
\\054\000\061\000\000\000\
\\000\000\
\\000\000\
\\018\000\159\000\019\000\109\000\000\000\
\\000\000\
\\026\000\164\000\027\000\163\000\028\000\065\000\029\000\162\000\
\\030\000\161\000\044\000\064\000\052\000\063\000\053\000\062\000\
\\054\000\061\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\028\000\191\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\192\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\023\000\193\000\028\000\136\000\044\000\064\000\052\000\063\000\
\\053\000\135\000\054\000\134\000\000\000\
\\022\000\194\000\023\000\137\000\028\000\136\000\044\000\064\000\
\\052\000\063\000\053\000\135\000\054\000\134\000\000\000\
\\033\000\203\000\034\000\202\000\035\000\201\000\037\000\200\000\
\\038\000\199\000\044\000\198\000\052\000\197\000\053\000\196\000\
\\054\000\195\000\000\000\
\\036\000\211\000\037\000\210\000\038\000\199\000\040\000\209\000\
\\041\000\208\000\044\000\198\000\052\000\197\000\053\000\196\000\
\\054\000\207\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\045\000\117\000\046\000\084\000\047\000\083\000\048\000\213\000\
\\049\000\082\000\052\000\063\000\053\000\081\000\054\000\061\000\
\\055\000\080\000\000\000\
\\052\000\063\000\053\000\214\000\054\000\061\000\000\000\
\\000\000\
\\045\000\216\000\046\000\084\000\047\000\083\000\048\000\215\000\
\\049\000\082\000\052\000\063\000\053\000\081\000\054\000\061\000\
\\055\000\080\000\000\000\
\\046\000\217\000\047\000\083\000\052\000\063\000\053\000\081\000\
\\054\000\061\000\055\000\080\000\000\000\
\\015\000\218\000\016\000\120\000\054\000\119\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\024\000\220\000\025\000\067\000\027\000\066\000\028\000\065\000\
\\044\000\064\000\052\000\063\000\053\000\062\000\054\000\061\000\000\000\
\\000\000\
\\039\000\221\000\000\000\
\\000\000\
\\000\000\
\\028\000\224\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\225\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\226\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\227\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\228\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\229\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\230\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\231\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\232\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\233\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\234\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\235\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\236\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\237\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\238\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\239\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\240\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\241\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\242\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\243\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\244\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\245\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\246\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\028\000\247\000\044\000\064\000\052\000\063\000\053\000\097\000\
\\054\000\061\000\000\000\
\\022\000\248\000\023\000\137\000\028\000\136\000\044\000\064\000\
\\052\000\063\000\053\000\135\000\054\000\134\000\000\000\
\\054\000\249\000\000\000\
\\039\000\250\000\000\000\
\\039\000\251\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\038\000\001\001\041\000\000\001\044\000\198\000\052\000\255\000\
\\054\000\254\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\033\000\004\001\034\000\202\000\035\000\201\000\037\000\200\000\
\\038\000\199\000\044\000\198\000\052\000\197\000\053\000\196\000\
\\054\000\195\000\000\000\
\\033\000\008\001\034\000\202\000\035\000\201\000\037\000\200\000\
\\038\000\199\000\042\000\007\001\043\000\006\001\044\000\198\000\
\\052\000\197\000\053\000\196\000\054\000\195\000\000\000\
\\000\000\
\\000\000\
\\020\000\009\001\000\000\
\\000\000\
\\000\000\
\\033\000\008\001\034\000\202\000\035\000\201\000\037\000\200\000\
\\038\000\199\000\042\000\012\001\043\000\006\001\044\000\198\000\
\\052\000\197\000\053\000\196\000\054\000\195\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\036\000\211\000\037\000\210\000\038\000\199\000\040\000\014\001\
\\041\000\208\000\044\000\198\000\052\000\197\000\053\000\196\000\
\\054\000\207\000\000\000\
\\026\000\015\001\027\000\163\000\028\000\065\000\044\000\064\000\
\\052\000\063\000\053\000\062\000\054\000\061\000\000\000\
\\039\000\016\001\000\000\
\\039\000\017\001\000\000\
\\039\000\018\001\000\000\
\\039\000\019\001\000\000\
\\039\000\020\001\000\000\
\\039\000\021\001\000\000\
\\039\000\022\001\000\000\
\\039\000\023\001\000\000\
\\039\000\024\001\000\000\
\\039\000\025\001\000\000\
\\039\000\026\001\000\000\
\\039\000\027\001\000\000\
\\039\000\028\001\000\000\
\\039\000\029\001\000\000\
\\039\000\030\001\000\000\
\\039\000\031\001\000\000\
\\039\000\032\001\000\000\
\\039\000\033\001\000\000\
\\039\000\034\001\000\000\
\\039\000\035\001\000\000\
\\039\000\036\001\000\000\
\\039\000\037\001\000\000\
\\039\000\038\001\000\000\
\\039\000\039\001\000\000\
\\000\000\
\\036\000\211\000\037\000\210\000\038\000\199\000\040\000\040\001\
\\041\000\208\000\044\000\198\000\052\000\197\000\053\000\196\000\
\\054\000\207\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\033\000\041\001\034\000\202\000\035\000\201\000\037\000\200\000\
\\038\000\199\000\044\000\198\000\052\000\197\000\053\000\196\000\
\\054\000\195\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\034\000\042\001\035\000\201\000\037\000\200\000\038\000\199\000\
\\044\000\198\000\052\000\197\000\053\000\196\000\054\000\207\000\000\000\
\\024\000\043\001\025\000\067\000\027\000\066\000\028\000\065\000\
\\044\000\064\000\052\000\063\000\053\000\062\000\054\000\061\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\026\000\164\000\027\000\163\000\028\000\065\000\029\000\048\001\
\\030\000\161\000\044\000\064\000\052\000\063\000\053\000\062\000\
\\054\000\061\000\000\000\
\\036\000\050\001\037\000\210\000\038\000\199\000\044\000\198\000\
\\052\000\197\000\053\000\196\000\054\000\207\000\000\000\
\\000\000\
\\052\000\063\000\053\000\214\000\054\000\061\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\020\000\052\001\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\033\000\008\001\034\000\202\000\035\000\201\000\037\000\200\000\
\\038\000\199\000\043\000\053\001\044\000\198\000\052\000\197\000\
\\053\000\196\000\054\000\195\000\000\000\
\\000\000\
\\033\000\008\001\034\000\202\000\035\000\201\000\037\000\200\000\
\\038\000\199\000\043\000\054\001\044\000\198\000\052\000\197\000\
\\053\000\196\000\054\000\195\000\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\\000\000\
\"
val numstates = 313
val numrules = 159
val s = ref "" and index = ref 0
val string_to_int = fn () => 
let val i = !index
in index := i+2; Char.ord(String.sub(!s,i)) + Char.ord(String.sub(!s,i+1)) * 256
end
val string_to_list = fn s' =>
    let val len = String.size s'
        fun f () =
           if !index < len then string_to_int() :: f()
           else nil
   in index := 0; s := s'; f ()
   end
val string_to_pairlist = fn (conv_key,conv_entry) =>
     let fun f () =
         case string_to_int()
         of 0 => EMPTY
          | n => PAIR(conv_key (n-1),conv_entry (string_to_int()),f())
     in f
     end
val string_to_pairlist_default = fn (conv_key,conv_entry) =>
    let val conv_row = string_to_pairlist(conv_key,conv_entry)
    in fn () =>
       let val default = conv_entry(string_to_int())
           val row = conv_row()
       in (row,default)
       end
   end
val string_to_table = fn (convert_row,s') =>
    let val len = String.size s'
        fun f ()=
           if !index < len then convert_row() :: f()
           else nil
     in (s := s'; index := 0; f ())
     end
local
  val memo = Array.array(numstates+numrules,ERROR)
  val _ =let fun g i=(Array.update(memo,i,REDUCE(i-numstates)); g(i+1))
       fun f i =
            if i=numstates then g i
            else (Array.update(memo,i,SHIFT (STATE i)); f (i+1))
          in f 0 handle Subscript => ()
          end
in
val entry_to_action = fn 0 => ACCEPT | 1 => ERROR | j => Array.sub(memo,(j-2))
end
val gotoT=Array.fromList(string_to_table(string_to_pairlist(NT,STATE),gotoT))
val actionRows=string_to_table(string_to_pairlist_default(T,entry_to_action),actionRows)
val actionRowNumbers = string_to_list actionRowNumbers
val actionT = let val actionRowLookUp=
let val a=Array.fromList(actionRows) in fn i=>Array.sub(a,i) end
in Array.fromList(map actionRowLookUp actionRowNumbers)
end
in LrTable.mkLrTable {actions=actionT,gotos=gotoT,numRules=numrules,
numStates=numstates,initialState=STATE 0}
end
end
local open Header in
type pos = LexArg.pos
type arg =  ( int*int )  -> { fileName:string,sline:int,scolumn:int,eline:int,ecolumn:int } 
structure MlyValue = 
struct
datatype svalue = VOID | ntVOID of unit | TYVAR of  (string)
 | SCON of  (string) | RCON of  (real) | IDENT of  (string)
 | ICON of  (int) | CCON of  (char) | tyvar of  (Absyn.ident)
 | ident of  (Absyn.ident) | longorshortid of  (Absyn.longid)
 | longid of  (Absyn.longid) | tyvar_comma_plus of  (Absyn.ident list)
 | tyvarseq of  (Absyn.ident list) | seq_ty of  (Absyn.ty list)
 | ty_comma_seq2 of  (Absyn.ty list) | ty_sans_star of  (Absyn.ty)
 | tuple_ty of  (Absyn.ty list) | ty of  (Absyn.ty)
 | literal of  (Absyn.lit) | pat_comma_plus of  (Absyn.pat list)
 | pat_comma_star of  (Absyn.pat list) | pat_star of  (Absyn.pat list)
 | seq_pat of  (Absyn.pat list) | res_pat of  (Absyn.pat list)
 | pat_e of  (Absyn.pat) | pat_d of  (Absyn.pat)
 | pat_c of  (Absyn.pat) | pat_b of  (Absyn.pat)
 | pat_a of  (Absyn.pat) | pat of  (Absyn.pat)
 | exp_comma_plus of  (Absyn.exp list)
 | exp_comma_star of  (Absyn.exp list) | exp_star of  (Absyn.exp list)
 | seq_exp of  (Absyn.exp list) | exp_d of  (Absyn.exp)
 | exp_c of  (Absyn.exp) | exp_b of  (Absyn.exp)
 | exp_a of  (Absyn.exp) | exp of  (Absyn.exp)
 | atomic_goal of  (Absyn.goal) | conjunctive_goal of  (Absyn.goal)
 | conjunctive_goal_opt of  (Absyn.goal option)
 | result of  (Absyn.result) | clause of  (Absyn.clause)
 | clause_plus of  (Absyn.clause)
 | default_opt of  (Absyn.clause option) | conbind of  (Absyn.conbind)
 | conbind_plus of  (Absyn.conbind list) | datbind of  (Absyn.datbind)
 | datbind_plus of  (Absyn.datbind list) | typbind of  (Absyn.typbind)
 | typbind_plus of  (Absyn.typbind list)
 | withbind of  (Absyn.typbind list)
 | relbind_ty_opt of  (Absyn.ty option)
 | relbind_plus of  (Absyn.relbind list) | relbind of  (Absyn.relbind)
 | dec of  (Absyn.dec) | dec_star of  (Absyn.dec list)
 | spec of  (Absyn.spec) | spec_star of  (Absyn.spec list)
 | interface of  (Absyn.interface) | module of  (Absyn.module)
end
type svalue = MlyValue.svalue
type result = Absyn.module
end
structure EC=
struct
open LrTable
infix 5 $$
fun x $$ y = y::x
val is_keyword =
fn (T 1) => true | (T 2) => true | (T 3) => true | (T 10) => true | 
(T 11) => true | (T 13) => true | (T 17) => true | (T 18) => true | 
(T 23) => true | (T 25) => true | (T 26) => true | (T 27) => true | 
(T 29) => true | (T 32) => true | (T 37) => true | (T 39) => true | 
(T 41) => true | (T 42) => true | _ => false
val preferred_change : (term list * term list) list = 
nil
val noShift = 
fn (T 14) => true | _ => false
val showTerminal =
fn (T 0) => "AMPERSAND"
  | (T 1) => "AND"
  | (T 2) => "AS"
  | (T 3) => "AXIOM"
  | (T 4) => "BAR"
  | (T 5) => "CCON"
  | (T 6) => "COLON"
  | (T 7) => "COLONCOLON"
  | (T 8) => "COMMA"
  | (T 9) => "DASHES"
  | (T 10) => "DATATYPE"
  | (T 11) => "DEFAULT"
  | (T 12) => "DOT"
  | (T 13) => "END"
  | (T 14) => "EOF_HARD"
  | (T 15) => "EOF_SOFT"
  | (T 16) => "EQ"
  | (T 17) => "EQTYPE"
  | (T 18) => "FAIL"
  | (T 19) => "FATARROW"
  | (T 20) => "ICON"
  | (T 21) => "IDENT"
  | (T 22) => "LBRACK"
  | (T 23) => "LET"
  | (T 24) => "LPAREN"
  | (T 25) => "MODULE"
  | (T 26) => "NOT"
  | (T 27) => "OF"
  | (T 28) => "RCON"
  | (T 29) => "RELATION"
  | (T 30) => "RBRACK"
  | (T 31) => "RPAREN"
  | (T 32) => "RULE"
  | (T 33) => "SCON"
  | (T 34) => "STAR"
  | (T 35) => "START_MODULE"
  | (T 36) => "START_INTERFACE"
  | (T 37) => "TYPE"
  | (T 38) => "TYVAR"
  | (T 39) => "VAL"
  | (T 40) => "WILD"
  | (T 41) => "WITH"
  | (T 42) => "WITHTYPE"
  | (T 43) => "ADD_INT"
  | (T 44) => "SUB_INT"
  | (T 45) => "NEG_INT"
  | (T 46) => "DIV_INT"
  | (T 47) => "MOD_INT"
  | (T 48) => "EQ_INT"
  | (T 49) => "GE_INT"
  | (T 50) => "GT_INT"
  | (T 51) => "LE_INT"
  | (T 52) => "LT_INT"
  | (T 53) => "NE_INT"
  | (T 54) => "ADD_REAL"
  | (T 55) => "SUB_REAL"
  | (T 56) => "NEG_REAL"
  | (T 57) => "MUL_REAL"
  | (T 58) => "DIV_REAL"
  | (T 59) => "MOD_REAL"
  | (T 60) => "POW_REAL"
  | (T 61) => "EQ_REAL"
  | (T 62) => "GE_REAL"
  | (T 63) => "GT_REAL"
  | (T 64) => "LE_REAL"
  | (T 65) => "LT_REAL"
  | (T 66) => "NE_REAL"
  | (T 67) => "ADD_STRING"
  | (T 68) => "ADD_LIST"
  | _ => "bogus-term"
local open Header in
val errtermvalue=
fn _ => MlyValue.VOID
end
val terms : term list = nil
 $$ (T 68) $$ (T 67) $$ (T 66) $$ (T 65) $$ (T 64) $$ (T 63) $$ (T 62)
 $$ (T 61) $$ (T 60) $$ (T 59) $$ (T 58) $$ (T 57) $$ (T 56) $$ (T 55)
 $$ (T 54) $$ (T 53) $$ (T 52) $$ (T 51) $$ (T 50) $$ (T 49) $$ (T 48)
 $$ (T 47) $$ (T 46) $$ (T 45) $$ (T 44) $$ (T 43) $$ (T 42) $$ (T 41)
 $$ (T 40) $$ (T 39) $$ (T 37) $$ (T 36) $$ (T 35) $$ (T 34) $$ (T 32)
 $$ (T 31) $$ (T 30) $$ (T 29) $$ (T 27) $$ (T 26) $$ (T 25) $$ (T 24)
 $$ (T 23) $$ (T 22) $$ (T 19) $$ (T 18) $$ (T 17) $$ (T 16) $$ (T 15)
 $$ (T 14) $$ (T 13) $$ (T 12) $$ (T 11) $$ (T 10) $$ (T 9) $$ (T 8)
 $$ (T 7) $$ (T 6) $$ (T 4) $$ (T 3) $$ (T 2) $$ (T 1) $$ (T 0)end
structure Actions =
struct 
exception mlyAction of int
local open Header in
val actions = 
fn (i392,defaultPos,stack,
    (myLoc):arg) =>
case (i392,stack)
of (0,(_,(_,_,EOF_SOFT1right))::(_,(MlyValue.dec_star dec_star,_,
dec_starright))::(_,(MlyValue.interface interface,interfaceleft,_))::(
_,(_,START_MODULE1left,_))::rest671) => let val result=MlyValue.module
((
 Absyn.MODULE(interface, dec_star, 
			makeInfo myLoc (interfaceleft, dec_starright)) 
))
 in (LrTable.NT 0,(result,START_MODULE1left,EOF_SOFT1right),rest671)
 end
| (1,(_,(MlyValue.interface interface,_,interfaceright as 
interface1right))::(_,(_,START_INTERFACEleft as START_INTERFACE1left,_
))::rest671) => let val result=MlyValue.module((
 Absyn.MODULE(interface, [], 
			makeInfo myLoc (START_INTERFACEleft, interfaceright)) 
))
 in (LrTable.NT 0,(result,START_INTERFACE1left,interface1right),
rest671) end
| (2,(_,(_,_,ENDright as END1right))::(_,(MlyValue.spec_star spec_star
,_,_))::(_,(_,COLONleft,_))::(_,(MlyValue.ident ident,_,_))::(_,(_,
MODULE1left,_))::rest671) => let val result=MlyValue.interface((
 Absyn.INTERFACE({modid=ident, specs=spec_star, source=Absyn.Source.dummy},
		  makeInfo myLoc (COLONleft, ENDright)) 
))
 in (LrTable.NT 1,(result,MODULE1left,END1right),rest671) end
| (3,rest671) => let val result=MlyValue.spec_star(( [] ))
 in (LrTable.NT 2,(result,defaultPos,defaultPos),rest671) end
| (4,(_,(MlyValue.spec_star spec_star,_,spec_star1right))::(_,(
MlyValue.spec spec,spec1left,_))::rest671) => let val result=
MlyValue.spec_star(( spec :: spec_star ))
 in (LrTable.NT 2,(result,spec1left,spec_star1right),rest671) end
| (5,(_,(MlyValue.SCON SCON,_,SCONright as SCON1right))::(_,(_,
WITHleft as WITH1left,_))::rest671) => let val result=MlyValue.spec((
 Absyn.WITHspec(SCON, ref(Absyn.dummyInterface), 
			makeInfo myLoc (WITHleft, SCONright)) 
))
 in (LrTable.NT 3,(result,WITH1left,SCON1right),rest671) end
| (6,(_,(MlyValue.ident ident,_,identright as ident1right))::(_,(
MlyValue.tyvarseq tyvarseq,_,_))::(_,(_,TYPEleft as TYPE1left,_))::
rest671) => let val result=MlyValue.spec((
 Absyn.ABSTYPEspec(false, tyvarseq, ident,
			makeInfo myLoc (TYPEleft, identright)) 
))
 in (LrTable.NT 3,(result,TYPE1left,ident1right),rest671) end
| (7,(_,(MlyValue.ident ident,_,identright as ident1right))::(_,(
MlyValue.tyvarseq tyvarseq,_,_))::(_,(_,EQTYPEleft as EQTYPE1left,_))
::rest671) => let val result=MlyValue.spec((
 Absyn.ABSTYPEspec(true, tyvarseq, ident, 
			makeInfo myLoc (EQTYPEleft, identright)) 
))
 in (LrTable.NT 3,(result,EQTYPE1left,ident1right),rest671) end
| (8,(_,(MlyValue.typbind_plus typbind_plus,_,typbind_plusright as 
typbind_plus1right))::(_,(_,TYPEleft as TYPE1left,_))::rest671) => 
let val result=MlyValue.spec((
 Absyn.TYPEspec(typbind_plus,
			makeInfo myLoc (TYPEleft, typbind_plusright)) 
))
 in (LrTable.NT 3,(result,TYPE1left,typbind_plus1right),rest671) end
| (9,(_,(MlyValue.withbind withbind,_,withbindright as withbind1right)
)::(_,(MlyValue.datbind_plus datbind_plus,_,_))::(_,(_,DATATYPEleft
 as DATATYPE1left,_))::rest671) => let val result=MlyValue.spec((
 Absyn.DATAspec(datbind_plus, withbind,
			makeInfo myLoc (DATATYPEleft, withbindright)) 
))
 in (LrTable.NT 3,(result,DATATYPE1left,withbind1right),rest671) end
| (10,(_,(MlyValue.ty ty,_,tyright as ty1right))::_::(_,(
MlyValue.ident ident,_,_))::(_,(_,VALleft as VAL1left,_))::rest671)
 => let val result=MlyValue.spec((
 Absyn.VALspec(ident, ty,
			makeInfo myLoc (VALleft, tyright)) ))
 in (LrTable.NT 3,(result,VAL1left,ty1right),rest671) end
| (11,(_,(MlyValue.ty ty,_,tyright as ty1right))::_::(_,(
MlyValue.ident ident,_,_))::(_,(_,RELATIONleft as RELATION1left,_))::
rest671) => let val result=MlyValue.spec((
 Absyn.RELspec(ident, ty,
			makeInfo myLoc (RELATIONleft, tyright)) )
)
 in (LrTable.NT 3,(result,RELATION1left,ty1right),rest671) end
| (12,rest671) => let val result=MlyValue.dec_star(( [] ))
 in (LrTable.NT 4,(result,defaultPos,defaultPos),rest671) end
| (13,(_,(MlyValue.dec_star dec_star,_,dec_star1right))::(_,(
MlyValue.dec dec,dec1left,_))::rest671) => let val result=
MlyValue.dec_star(( dec :: dec_star ))
 in (LrTable.NT 4,(result,dec1left,dec_star1right),rest671) end
| (14,(_,(MlyValue.SCON SCON,_,SCONright as SCON1right))::(_,(_,
WITHleft as WITH1left,_))::rest671) => let val result=MlyValue.dec((
 Absyn.WITHdec(SCON, ref(Absyn.dummyInterface),
			makeInfo myLoc (WITHleft, SCONright)) 
))
 in (LrTable.NT 5,(result,WITH1left,SCON1right),rest671) end
| (15,(_,(MlyValue.typbind_plus typbind_plus,_,typbind_plusright as 
typbind_plus1right))::(_,(_,TYPEleft as TYPE1left,_))::rest671) => 
let val result=MlyValue.dec((
 Absyn.TYPEdec(typbind_plus,
			makeInfo myLoc (TYPEleft, typbind_plusright)) 
))
 in (LrTable.NT 5,(result,TYPE1left,typbind_plus1right),rest671) end
| (16,(_,(MlyValue.withbind withbind,_,withbindright as withbind1right
))::(_,(MlyValue.datbind_plus datbind_plus,_,_))::(_,(_,DATATYPEleft
 as DATATYPE1left,_))::rest671) => let val result=MlyValue.dec((
 Absyn.DATAdec(datbind_plus, withbind,
			makeInfo myLoc (DATATYPEleft, withbindright)) 
))
 in (LrTable.NT 5,(result,DATATYPE1left,withbind1right),rest671) end
| (17,(_,(MlyValue.exp exp,_,expright as exp1right))::_::(_,(
MlyValue.ident ident,_,_))::(_,(_,VALleft as VAL1left,_))::rest671)
 => let val result=MlyValue.dec((
 Absyn.VALdec(ident, exp,
			makeInfo myLoc (VALleft, expright)) ))
 in (LrTable.NT 5,(result,VAL1left,exp1right),rest671) end
| (18,(_,(MlyValue.relbind_plus relbind_plus,_,relbind_plusright as 
relbind_plus1right))::(_,(_,RELATIONleft as RELATION1left,_))::rest671
) => let val result=MlyValue.dec((
 Absyn.RELdec(relbind_plus,
			makeInfo myLoc (RELATIONleft, relbind_plusright)) 
))
 in (LrTable.NT 5,(result,RELATION1left,relbind_plus1right),rest671)
 end
| (19,(_,(MlyValue.relbind_plus relbind_plus,_,relbind_plus1right))::_
::(_,(MlyValue.relbind relbind,relbind1left,_))::rest671) => let val 
result=MlyValue.relbind_plus(( relbind :: relbind_plus ))
 in (LrTable.NT 7,(result,relbind1left,relbind_plus1right),rest671)
 end
| (20,(_,(MlyValue.relbind relbind,relbind1left,relbind1right))::
rest671) => let val result=MlyValue.relbind_plus(( [relbind] ))
 in (LrTable.NT 7,(result,relbind1left,relbind1right),rest671) end
| (21,(_,(_,_,ENDright as END1right))::(_,(MlyValue.default_opt 
default_opt,_,_))::(_,(MlyValue.clause_plus clause_plus,_,_))::_::(_,(
MlyValue.relbind_ty_opt relbind_ty_opt,_,_))::(_,(MlyValue.ident ident
,identleft as ident1left,_))::rest671) => let val result=
MlyValue.relbind((
 Absyn.RELBIND(ident, relbind_ty_opt, join_default(clause_plus,default_opt),
			makeInfo myLoc (identleft, ENDright)) 
))
 in (LrTable.NT 6,(result,ident1left,END1right),rest671) end
| (22,(_,(MlyValue.ty ty,_,ty1right))::(_,(_,COLON1left,_))::rest671)
 => let val result=MlyValue.relbind_ty_opt(( SOME(ty) ))
 in (LrTable.NT 8,(result,COLON1left,ty1right),rest671) end
| (23,rest671) => let val result=MlyValue.relbind_ty_opt(( NONE ))
 in (LrTable.NT 8,(result,defaultPos,defaultPos),rest671) end
| (24,rest671) => let val result=MlyValue.withbind(( [] ))
 in (LrTable.NT 9,(result,defaultPos,defaultPos),rest671) end
| (25,(_,(MlyValue.typbind_plus typbind_plus,_,typbind_plus1right))::(
_,(_,WITHTYPE1left,_))::rest671) => let val result=MlyValue.withbind((
 typbind_plus ))
 in (LrTable.NT 9,(result,WITHTYPE1left,typbind_plus1right),rest671)
 end
| (26,(_,(MlyValue.typbind_plus typbind_plus,_,typbind_plus1right))::_
::(_,(MlyValue.typbind typbind,typbind1left,_))::rest671) => let val 
result=MlyValue.typbind_plus(( typbind :: typbind_plus ))
 in (LrTable.NT 10,(result,typbind1left,typbind_plus1right),rest671)
 end
| (27,(_,(MlyValue.typbind typbind,typbind1left,typbind1right))::
rest671) => let val result=MlyValue.typbind_plus(( [typbind] ))
 in (LrTable.NT 10,(result,typbind1left,typbind1right),rest671) end
| (28,(_,(MlyValue.ty ty,_,tyright as ty1right))::_::(_,(
MlyValue.ident ident,_,_))::(_,(MlyValue.tyvarseq tyvarseq,
tyvarseqleft as tyvarseq1left,_))::rest671) => let val result=
MlyValue.typbind((
 Absyn.TYPBIND(tyvarseq, ident, ty,
			makeInfo myLoc (tyvarseqleft, tyright)) 
))
 in (LrTable.NT 11,(result,tyvarseq1left,ty1right),rest671) end
| (29,(_,(MlyValue.datbind_plus datbind_plus,_,datbind_plus1right))::_
::(_,(MlyValue.datbind datbind,datbind1left,_))::rest671) => let val 
result=MlyValue.datbind_plus(( datbind :: datbind_plus ))
 in (LrTable.NT 12,(result,datbind1left,datbind_plus1right),rest671)
 end
| (30,(_,(MlyValue.datbind datbind,datbind1left,datbind1right))::
rest671) => let val result=MlyValue.datbind_plus(( [datbind] ))
 in (LrTable.NT 12,(result,datbind1left,datbind1right),rest671) end
| (31,(_,(MlyValue.conbind_plus conbind_plus,_,conbind_plusright as 
conbind_plus1right))::_::(_,(MlyValue.ident ident,_,_))::(_,(
MlyValue.tyvarseq tyvarseq,tyvarseqleft as tyvarseq1left,_))::rest671)
 => let val result=MlyValue.datbind((
 Absyn.DATBIND(tyvarseq, ident, conbind_plus,
			makeInfo myLoc (tyvarseqleft, conbind_plusright)) 
))
 in (LrTable.NT 13,(result,tyvarseq1left,conbind_plus1right),rest671)
 end
| (32,(_,(MlyValue.conbind_plus conbind_plus,_,conbind_plus1right))::_
::(_,(MlyValue.conbind conbind,conbind1left,_))::rest671) => let val 
result=MlyValue.conbind_plus(( conbind :: conbind_plus ))
 in (LrTable.NT 14,(result,conbind1left,conbind_plus1right),rest671)
 end
| (33,(_,(MlyValue.conbind conbind,conbind1left,conbind1right))::
rest671) => let val result=MlyValue.conbind_plus(( [conbind] ))
 in (LrTable.NT 14,(result,conbind1left,conbind1right),rest671) end
| (34,(_,(MlyValue.ident ident,identleft as ident1left,identright as 
ident1right))::rest671) => let val result=MlyValue.conbind((
 Absyn.CONcb(ident,
			makeInfo myLoc (identleft, identright)) ))
 in (LrTable.NT 15,(result,ident1left,ident1right),rest671) end
| (35,(_,(MlyValue.tuple_ty tuple_ty,_,tuple_tyright as tuple_ty1right
))::_::(_,(MlyValue.ident ident,identleft as ident1left,_))::rest671)
 => let val result=MlyValue.conbind((
 Absyn.CTORcb(ident, tuple_ty,
			makeInfo myLoc (identleft, tuple_tyright)) 
))
 in (LrTable.NT 15,(result,ident1left,tuple_ty1right),rest671) end
| (36,rest671) => let val result=MlyValue.default_opt(( NONE ))
 in (LrTable.NT 16,(result,defaultPos,defaultPos),rest671) end
| (37,(_,(MlyValue.clause_plus clause_plus,_,clause_plus1right))::(_,(
_,DEFAULT1left,_))::rest671) => let val result=MlyValue.default_opt((
 SOME(clause_plus) ))
 in (LrTable.NT 16,(result,DEFAULT1left,clause_plus1right),rest671)
 end
| (38,(_,(MlyValue.clause clause,clause1left,clause1right))::rest671)
 => let val result=MlyValue.clause_plus(( clause ))
 in (LrTable.NT 17,(result,clause1left,clause1right),rest671) end
| (39,(_,(MlyValue.clause_plus clause_plus,_,clause_plusright as 
clause_plus1right))::(_,(MlyValue.clause clause,clauseleft as 
clause1left,_))::rest671) => let val result=MlyValue.clause_plus((
 Absyn.CLAUSE2(clause, clause_plus,
			makeInfo myLoc (clauseleft, clause_plusright)) 
))
 in (LrTable.NT 17,(result,clause1left,clause_plus1right),rest671) end
| (40,(_,(MlyValue.result result,_,resultright as result1right))::(_,(
MlyValue.seq_pat seq_pat,_,_))::(_,(MlyValue.ident ident,_,_))::_::(_,
(MlyValue.conjunctive_goal_opt conjunctive_goal_opt,_,_))::(_,(_,
RULEleft as RULE1left,_))::rest671) => let val result=MlyValue.clause(
(
 Absyn.CLAUSE1(conjunctive_goal_opt, ident, seq_pat, result,
			makeInfo myLoc (RULEleft, resultright)) 
))
 in (LrTable.NT 18,(result,RULE1left,result1right),rest671) end
| (41,(_,(MlyValue.result result,_,resultright as result1right))::(_,(
MlyValue.seq_pat seq_pat,_,_))::(_,(MlyValue.ident ident,_,_))::(_,(_,
AXIOMleft as AXIOM1left,_))::rest671) => let val result=
MlyValue.clause((
 Absyn.CLAUSE1(NONE, ident, seq_pat, result,
			makeInfo myLoc (AXIOMleft, resultright)) 
))
 in (LrTable.NT 18,(result,AXIOM1left,result1right),rest671) end
| (42,rest671) => let val result=MlyValue.result((
 Absyn.RETURN([], makeInfo myLoc (0, 0)) ))
 in (LrTable.NT 19,(result,defaultPos,defaultPos),rest671) end
| (43,(_,(MlyValue.seq_exp seq_exp,_,seq_expright as seq_exp1right))::
(_,(_,FATARROWleft as FATARROW1left,_))::rest671) => let val result=
MlyValue.result((
 Absyn.RETURN(seq_exp, 
			makeInfo myLoc (FATARROWleft, seq_expright)) 
))
 in (LrTable.NT 19,(result,FATARROW1left,seq_exp1right),rest671) end
| (44,(_,(_,_,FAILright as FAIL1right))::(_,(_,FATARROWleft as 
FATARROW1left,_))::rest671) => let val result=MlyValue.result((
 Absyn.FAIL (makeInfo myLoc (FATARROWleft, FAILright)) ))
 in (LrTable.NT 19,(result,FATARROW1left,FAIL1right),rest671) end
| (45,rest671) => let val result=MlyValue.conjunctive_goal_opt(( NONE 
))
 in (LrTable.NT 20,(result,defaultPos,defaultPos),rest671) end
| (46,(_,(MlyValue.conjunctive_goal conjunctive_goal,
conjunctive_goal1left,conjunctive_goal1right))::rest671) => let val 
result=MlyValue.conjunctive_goal_opt(( SOME(conjunctive_goal) ))
 in (LrTable.NT 20,(result,conjunctive_goal1left,
conjunctive_goal1right),rest671) end
| (47,(_,(MlyValue.atomic_goal atomic_goal,atomic_goal1left,
atomic_goal1right))::rest671) => let val result=
MlyValue.conjunctive_goal(( atomic_goal ))
 in (LrTable.NT 21,(result,atomic_goal1left,atomic_goal1right),rest671
) end
| (48,(_,(MlyValue.conjunctive_goal conjunctive_goal,_,
conjunctive_goalright as conjunctive_goal1right))::_::(_,(
MlyValue.atomic_goal atomic_goal,atomic_goalleft as atomic_goal1left,_
))::rest671) => let val result=MlyValue.conjunctive_goal((
 Absyn.ANDgoal(atomic_goal, conjunctive_goal,
			makeInfo myLoc (atomic_goalleft, conjunctive_goalright)) 
))
 in (LrTable.NT 21,(result,atomic_goal1left,conjunctive_goal1right),
rest671) end
| (49,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.seq_exp seq_exp,_,_))::(_,(MlyValue.longorshortid 
longorshortid,longorshortidleft as longorshortid1left,_))::rest671)
 => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(longorshortid, seq_exp, res_pat,
			makeInfo myLoc (longorshortidleft, res_patright)) 
))
 in (LrTable.NT 22,(result,longorshortid1left,res_pat1right),rest671)
 end
| (50,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_add_int, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (51,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_sub_int, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (52,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d1,_,_))::(_,(_,NEG_INTleft as NEG_INT1left,_))
::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_neg_int, [exp_d1], res_pat,
			makeInfo myLoc (NEG_INTleft, res_patright)) 
))
 in (LrTable.NT 22,(result,NEG_INT1left,res_pat1right),rest671) end
| (53,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_mul_int, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (54,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_div_int, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (55,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_mod_int, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (56,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_eq_int, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (57,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_ge_int, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (58,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_gt_int, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (59,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_le_int, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (60,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_lt_int, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (61,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_ne_int, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (62,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_add_real, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (63,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_sub_real, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (64,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d1,_,_))::(_,(_,NEG_REALleft as NEG_REAL1left,_
))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_neg_real, [exp_d1], res_pat,
			makeInfo myLoc (NEG_REALleft, res_patright)) 
))
 in (LrTable.NT 22,(result,NEG_REAL1left,res_pat1right),rest671) end
| (65,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_mul_real, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (66,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_div_real, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (67,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_mod_real, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (68,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_pow_real, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (69,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_eq_real, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (70,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_ge_real, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (71,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_gt_real, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (72,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_le_real, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (73,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_lt_real, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (74,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_ne_real, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (75,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_add_string, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (76,(_,(MlyValue.res_pat res_pat,_,res_patright as res_pat1right))::
(_,(MlyValue.exp_d exp_d2,_,_))::_::(_,(MlyValue.exp_d exp_d1,
exp_d1left,_))::rest671) => let val result=MlyValue.atomic_goal((
 Absyn.CALLgoal(op_add_list, [exp_d1, exp_d2], res_pat,
			makeInfo myLoc (exp_d1left, res_patright)) 
))
 in (LrTable.NT 22,(result,exp_d1left,res_pat1right),rest671) end
| (77,(_,(MlyValue.exp exp,_,expright as exp1right))::_::(_,(
MlyValue.ident ident,identleft as ident1left,_))::rest671) => let val 
result=MlyValue.atomic_goal((
 Absyn.EQUALgoal(ident, exp,
			makeInfo myLoc (identleft, expright)) 
))
 in (LrTable.NT 22,(result,ident1left,exp1right),rest671) end
| (78,(_,(MlyValue.exp exp,_,expright as exp1right))::_::(_,(
MlyValue.pat pat,_,_))::(_,(_,LETleft as LET1left,_))::rest671) => 
let val result=MlyValue.atomic_goal((
 Absyn.LETgoal(pat, exp,
			makeInfo myLoc (LETleft, expright)) ))
 in (LrTable.NT 22,(result,LET1left,exp1right),rest671) end
| (79,(_,(MlyValue.atomic_goal atomic_goal,_,atomic_goalright as 
atomic_goal1right))::(_,(_,NOTleft as NOT1left,_))::rest671) => let 
val result=MlyValue.atomic_goal((
 Absyn.NOTgoal(atomic_goal,
			makeInfo myLoc (NOTleft, atomic_goalright)) 
))
 in (LrTable.NT 22,(result,NOT1left,atomic_goal1right),rest671) end
| (80,(_,(_,_,RPAREN1right))::(_,(MlyValue.conjunctive_goal 
conjunctive_goal,_,_))::(_,(_,LPAREN1left,_))::rest671) => let val 
result=MlyValue.atomic_goal(( conjunctive_goal ))
 in (LrTable.NT 22,(result,LPAREN1left,RPAREN1right),rest671) end
| (81,(_,(MlyValue.exp exp,_,expright as exp1right))::_::(_,(
MlyValue.exp_a exp_a,exp_aleft as exp_a1left,_))::rest671) => let val 
result=MlyValue.exp((
 Absyn.STRUCTexp(ctor_cons, [exp_a, exp], 
			makeInfo myLoc (exp_aleft, expright)) 
))
 in (LrTable.NT 23,(result,exp_a1left,exp1right),rest671) end
| (82,(_,(MlyValue.exp_a exp_a,exp_a1left,exp_a1right))::rest671) => 
let val result=MlyValue.exp(( exp_a ))
 in (LrTable.NT 23,(result,exp_a1left,exp_a1right),rest671) end
| (83,(_,(_,_,RPARENright as RPAREN1right))::(_,(_,LPARENleft as 
LPAREN1left,_))::rest671) => let val result=MlyValue.exp_a((
 Absyn.STRUCTexp(NONE, [],
			makeInfo myLoc (LPARENleft, RPARENright)) 
))
 in (LrTable.NT 24,(result,LPAREN1left,RPAREN1right),rest671) end
| (84,(_,(_,_,RPAREN1right))::(_,(MlyValue.exp exp,_,_))::(_,(_,
LPAREN1left,_))::rest671) => let val result=MlyValue.exp_a(( exp ))
 in (LrTable.NT 24,(result,LPAREN1left,RPAREN1right),rest671) end
| (85,(_,(_,_,RPARENright as RPAREN1right))::(_,(
MlyValue.exp_comma_plus exp_comma_plus,_,_))::_::(_,(MlyValue.exp exp,
_,_))::(_,(_,LPARENleft as LPAREN1left,_))::rest671) => let val result
=MlyValue.exp_a((
 Absyn.STRUCTexp(NONE, exp :: exp_comma_plus,
			makeInfo myLoc (LPARENleft, RPARENright)) 
))
 in (LrTable.NT 24,(result,LPAREN1left,RPAREN1right),rest671) end
| (86,(_,(MlyValue.exp_c exp_c,exp_c1left,exp_c1right))::rest671) => 
let val result=MlyValue.exp_a(( exp_c ))
 in (LrTable.NT 24,(result,exp_c1left,exp_c1right),rest671) end
| (87,(_,(MlyValue.exp_b exp_b,_,exp_bright as exp_b1right))::_::(_,(
MlyValue.exp_c exp_c,exp_cleft as exp_c1left,_))::rest671) => let val 
result=MlyValue.exp_b((
 Absyn.STRUCTexp(ctor_cons, [exp_c, exp_b],
			makeInfo myLoc (exp_cleft, exp_bright)) 
))
 in (LrTable.NT 25,(result,exp_c1left,exp_b1right),rest671) end
| (88,(_,(MlyValue.exp_c exp_c,exp_c1left,exp_c1right))::rest671) => 
let val result=MlyValue.exp_b(( exp_c ))
 in (LrTable.NT 25,(result,exp_c1left,exp_c1right),rest671) end
| (89,(_,(MlyValue.exp_star exp_star,_,exp_starright as exp_star1right
))::(_,(MlyValue.longorshortid longorshortid,longorshortidleft as 
longorshortid1left,_))::rest671) => let val result=MlyValue.exp_c((
 Absyn.STRUCTexp(SOME longorshortid, exp_star,
			makeInfo myLoc (longorshortidleft, exp_starright)) 
))
 in (LrTable.NT 26,(result,longorshortid1left,exp_star1right),rest671)
 end
| (90,(_,(MlyValue.exp_d exp_d,_,exp_dright as exp_d1right))::(_,(
MlyValue.longorshortid longorshortid,longorshortidleft as 
longorshortid1left,_))::rest671) => let val result=MlyValue.exp_c((
 Absyn.STRUCTexp(SOME longorshortid, [exp_d],
			makeInfo myLoc (longorshortidleft, exp_dright)) 
))
 in (LrTable.NT 26,(result,longorshortid1left,exp_d1right),rest671)
 end
| (91,(_,(MlyValue.exp_d exp_d,exp_d1left,exp_d1right))::rest671) => 
let val result=MlyValue.exp_c(( exp_d ))
 in (LrTable.NT 26,(result,exp_d1left,exp_d1right),rest671) end
| (92,(_,(MlyValue.literal literal,literal1left,literal1right))::
rest671) => let val result=MlyValue.exp_d((
 Absyn.LITexp(literal, 
			makeInfo myLoc (literal1left, literal1right)) 
))
 in (LrTable.NT 27,(result,literal1left,literal1right),rest671) end
| (93,(_,(MlyValue.longorshortid longorshortid,longorshortidleft as 
longorshortid1left,longorshortidright as longorshortid1right))::
rest671) => let val result=MlyValue.exp_d((
 Absyn.IDENTexp(longorshortid, ref(Absyn.STRUCTexp(NONE,[], ref(Absyn.dummyInfo))),
			makeInfo myLoc (longorshortidleft, longorshortidright)) 
))
 in (LrTable.NT 27,(result,longorshortid1left,longorshortid1right),
rest671) end
| (94,(_,(_,_,RBRACK1right))::(_,(MlyValue.exp_comma_star 
exp_comma_star,_,_))::(_,(_,LBRACK1left,_))::rest671) => let val 
result=MlyValue.exp_d(( mkexplst(exp_comma_star) ))
 in (LrTable.NT 27,(result,LBRACK1left,RBRACK1right),rest671) end
| (95,rest671) => let val result=MlyValue.seq_exp(( [] ))
 in (LrTable.NT 28,(result,defaultPos,defaultPos),rest671) end
| (96,(_,(MlyValue.exp_b exp_b,exp_b1left,exp_b1right))::rest671) => 
let val result=MlyValue.seq_exp(( [exp_b] ))
 in (LrTable.NT 28,(result,exp_b1left,exp_b1right),rest671) end
| (97,(_,(MlyValue.exp_star exp_star,exp_star1left,exp_star1right))::
rest671) => let val result=MlyValue.seq_exp(( exp_star ))
 in (LrTable.NT 28,(result,exp_star1left,exp_star1right),rest671) end
| (98,(_,(_,_,RPAREN1right))::(_,(MlyValue.exp_comma_star 
exp_comma_star,_,_))::(_,(_,LPAREN1left,_))::rest671) => let val 
result=MlyValue.exp_star(( exp_comma_star ))
 in (LrTable.NT 29,(result,LPAREN1left,RPAREN1right),rest671) end
| (99,rest671) => let val result=MlyValue.exp_comma_star(( [] ))
 in (LrTable.NT 30,(result,defaultPos,defaultPos),rest671) end
| (100,(_,(MlyValue.exp_comma_plus exp_comma_plus,exp_comma_plus1left,
exp_comma_plus1right))::rest671) => let val result=
MlyValue.exp_comma_star(( exp_comma_plus ))
 in (LrTable.NT 30,(result,exp_comma_plus1left,exp_comma_plus1right),
rest671) end
| (101,(_,(MlyValue.exp exp,exp1left,exp1right))::rest671) => let val 
result=MlyValue.exp_comma_plus(( [exp] ))
 in (LrTable.NT 31,(result,exp1left,exp1right),rest671) end
| (102,(_,(MlyValue.exp_comma_plus exp_comma_plus,_,
exp_comma_plus1right))::_::(_,(MlyValue.exp exp,exp1left,_))::rest671)
 => let val result=MlyValue.exp_comma_plus(( exp :: exp_comma_plus ))
 in (LrTable.NT 31,(result,exp1left,exp_comma_plus1right),rest671) end
| (103,(_,(MlyValue.pat pat,_,patright as pat1right))::_::(_,(
MlyValue.ident ident,identleft as ident1left,_))::rest671) => let val 
result=MlyValue.pat((
 Absyn.BINDpat(ident, pat,
			makeInfo myLoc (identleft, patright))))
 in (LrTable.NT 32,(result,ident1left,pat1right),rest671) end
| (104,(_,(MlyValue.pat_a pat_a,pat_a1left,pat_a1right))::rest671) => 
let val result=MlyValue.pat(( pat_a ))
 in (LrTable.NT 32,(result,pat_a1left,pat_a1right),rest671) end
| (105,(_,(MlyValue.pat_a pat_a,_,pat_aright as pat_a1right))::_::(_,(
MlyValue.pat_b pat_b,pat_bleft as pat_b1left,_))::rest671) => let val 
result=MlyValue.pat_a((
 Absyn.STRUCTpat(ctor_cons, [pat_b, pat_a], 
			makeInfo myLoc (pat_bleft, pat_aright)) 
))
 in (LrTable.NT 33,(result,pat_b1left,pat_a1right),rest671) end
| (106,(_,(MlyValue.pat_b pat_b,pat_b1left,pat_b1right))::rest671) => 
let val result=MlyValue.pat_a(( pat_b ))
 in (LrTable.NT 33,(result,pat_b1left,pat_b1right),rest671) end
| (107,(_,(_,_,RPARENright as RPAREN1right))::(_,(_,LPARENleft as 
LPAREN1left,_))::rest671) => let val result=MlyValue.pat_b((
 Absyn.STRUCTpat(NONE, [],
			makeInfo myLoc (LPARENleft, RPARENright)) 
))
 in (LrTable.NT 34,(result,LPAREN1left,RPAREN1right),rest671) end
| (108,(_,(_,_,RPAREN1right))::(_,(MlyValue.pat pat,_,_))::(_,(_,
LPAREN1left,_))::rest671) => let val result=MlyValue.pat_b(( pat ))
 in (LrTable.NT 34,(result,LPAREN1left,RPAREN1right),rest671) end
| (109,(_,(_,_,RPARENright as RPAREN1right))::(_,(
MlyValue.pat_comma_plus pat_comma_plus,_,_))::_::(_,(MlyValue.pat pat,
_,_))::(_,(_,LPARENleft as LPAREN1left,_))::rest671) => let val result
=MlyValue.pat_b((
 Absyn.STRUCTpat(NONE, pat :: pat_comma_plus,
			makeInfo myLoc (LPARENleft, RPARENright)) 
))
 in (LrTable.NT 34,(result,LPAREN1left,RPAREN1right),rest671) end
| (110,(_,(MlyValue.pat_d pat_d,pat_d1left,pat_d1right))::rest671) => 
let val result=MlyValue.pat_b(( pat_d ))
 in (LrTable.NT 34,(result,pat_d1left,pat_d1right),rest671) end
| (111,(_,(MlyValue.pat_c pat_c,_,pat_cright as pat_c1right))::_::(_,(
MlyValue.pat_d pat_d,pat_dleft as pat_d1left,_))::rest671) => let val 
result=MlyValue.pat_c((
 Absyn.STRUCTpat(ctor_cons, [pat_d, pat_c],
			makeInfo myLoc (pat_dleft, pat_cright)) 
))
 in (LrTable.NT 35,(result,pat_d1left,pat_c1right),rest671) end
| (112,(_,(MlyValue.pat_d pat_d,pat_d1left,pat_d1right))::rest671) => 
let val result=MlyValue.pat_c(( pat_d ))
 in (LrTable.NT 35,(result,pat_d1left,pat_d1right),rest671) end
| (113,(_,(MlyValue.pat_star pat_star,_,pat_starright as 
pat_star1right))::(_,(MlyValue.longorshortid longorshortid,
longorshortidleft as longorshortid1left,_))::rest671) => let val 
result=MlyValue.pat_d((
 Absyn.STRUCTpat(SOME longorshortid, pat_star,
			makeInfo myLoc (longorshortidleft, pat_starright)) 
))
 in (LrTable.NT 36,(result,longorshortid1left,pat_star1right),rest671)
 end
| (114,(_,(MlyValue.pat_e pat_e,_,pat_eright as pat_e1right))::(_,(
MlyValue.longorshortid longorshortid,longorshortidleft as 
longorshortid1left,_))::rest671) => let val result=MlyValue.pat_d((
 Absyn.STRUCTpat(SOME longorshortid, [pat_e],
			makeInfo myLoc (longorshortidleft, pat_eright)) 
))
 in (LrTable.NT 36,(result,longorshortid1left,pat_e1right),rest671)
 end
| (115,(_,(MlyValue.pat_e pat_e,pat_e1left,pat_e1right))::rest671) => 
let val result=MlyValue.pat_d(( pat_e ))
 in (LrTable.NT 36,(result,pat_e1left,pat_e1right),rest671) end
| (116,(_,(_,WILDleft as WILD1left,WILDright as WILD1right))::rest671)
 => let val result=MlyValue.pat_e((
 Absyn.WILDpat(makeInfo myLoc (WILDleft, WILDright)) ))
 in (LrTable.NT 37,(result,WILD1left,WILD1right),rest671) end
| (117,(_,(MlyValue.literal literal,literalleft as literal1left,
literalright as literal1right))::rest671) => let val result=
MlyValue.pat_e((
 Absyn.LITpat(literal, 
			makeInfo myLoc (literalleft, literalright)) 
))
 in (LrTable.NT 37,(result,literal1left,literal1right),rest671) end
| (118,(_,(MlyValue.longid longid,longidleft as longid1left,
longidright as longid1right))::rest671) => let val result=
MlyValue.pat_e((
 Absyn.CONpat(longid,
			makeInfo myLoc (longidleft, longidright)) ))
 in (LrTable.NT 37,(result,longid1left,longid1right),rest671) end
| (119,(_,(MlyValue.ident ident,identleft as ident1left,identright as 
ident1right))::rest671) => let val result=MlyValue.pat_e((
 Absyn.IDENTpat(ident, ref(Absyn.WILDpat(ref(Absyn.dummyInfo))),
			makeInfo myLoc (identleft, identright)) 
))
 in (LrTable.NT 37,(result,ident1left,ident1right),rest671) end
| (120,(_,(_,_,RBRACK1right))::(_,(MlyValue.pat_comma_star 
pat_comma_star,_,_))::(_,(_,LBRACK1left,_))::rest671) => let val 
result=MlyValue.pat_e(( mkpatlst(pat_comma_star) ))
 in (LrTable.NT 37,(result,LBRACK1left,RBRACK1right),rest671) end
| (121,rest671) => let val result=MlyValue.res_pat(( [] ))
 in (LrTable.NT 38,(result,defaultPos,defaultPos),rest671) end
| (122,(_,(MlyValue.seq_pat seq_pat,_,seq_pat1right))::(_,(_,
FATARROW1left,_))::rest671) => let val result=MlyValue.res_pat((
 seq_pat ))
 in (LrTable.NT 38,(result,FATARROW1left,seq_pat1right),rest671) end
| (123,rest671) => let val result=MlyValue.seq_pat(( [] ))
 in (LrTable.NT 39,(result,defaultPos,defaultPos),rest671) end
| (124,(_,(MlyValue.pat_c pat_c,pat_c1left,pat_c1right))::rest671) => 
let val result=MlyValue.seq_pat(( [pat_c] ))
 in (LrTable.NT 39,(result,pat_c1left,pat_c1right),rest671) end
| (125,(_,(MlyValue.pat_star pat_star,pat_star1left,pat_star1right))::
rest671) => let val result=MlyValue.seq_pat(( pat_star ))
 in (LrTable.NT 39,(result,pat_star1left,pat_star1right),rest671) end
| (126,(_,(_,_,RPAREN1right))::(_,(MlyValue.pat_comma_star 
pat_comma_star,_,_))::(_,(_,LPAREN1left,_))::rest671) => let val 
result=MlyValue.pat_star(( pat_comma_star ))
 in (LrTable.NT 40,(result,LPAREN1left,RPAREN1right),rest671) end
| (127,rest671) => let val result=MlyValue.pat_comma_star(( [] ))
 in (LrTable.NT 41,(result,defaultPos,defaultPos),rest671) end
| (128,(_,(MlyValue.pat_comma_plus pat_comma_plus,pat_comma_plus1left,
pat_comma_plus1right))::rest671) => let val result=
MlyValue.pat_comma_star(( pat_comma_plus ))
 in (LrTable.NT 41,(result,pat_comma_plus1left,pat_comma_plus1right),
rest671) end
| (129,(_,(MlyValue.pat pat,pat1left,pat1right))::rest671) => let val 
result=MlyValue.pat_comma_plus(( [pat] ))
 in (LrTable.NT 42,(result,pat1left,pat1right),rest671) end
| (130,(_,(MlyValue.pat_comma_plus pat_comma_plus,_,
pat_comma_plus1right))::_::(_,(MlyValue.pat pat,pat1left,_))::rest671)
 => let val result=MlyValue.pat_comma_plus(( pat :: pat_comma_plus ))
 in (LrTable.NT 42,(result,pat1left,pat_comma_plus1right),rest671) end
| (131,(_,(MlyValue.CCON CCON,CCONleft as CCON1left,CCONright as 
CCON1right))::rest671) => let val result=MlyValue.literal((
 Absyn.CCONlit(CCON,
			makeInfo myLoc (CCONleft, CCONright)) ))
 in (LrTable.NT 43,(result,CCON1left,CCON1right),rest671) end
| (132,(_,(MlyValue.ICON ICON,ICONleft as ICON1left,ICONright as 
ICON1right))::rest671) => let val result=MlyValue.literal((
 Absyn.ICONlit(ICON,
			makeInfo myLoc (ICONleft, ICONright)) ))
 in (LrTable.NT 43,(result,ICON1left,ICON1right),rest671) end
| (133,(_,(MlyValue.RCON RCON,RCONleft as RCON1left,RCONright as 
RCON1right))::rest671) => let val result=MlyValue.literal((
 Absyn.RCONlit(RCON,
			makeInfo myLoc (RCONleft, RCONright)) ))
 in (LrTable.NT 43,(result,RCON1left,RCON1right),rest671) end
| (134,(_,(MlyValue.SCON SCON,SCONleft as SCON1left,SCONright as 
SCON1right))::rest671) => let val result=MlyValue.literal((
 Absyn.SCONlit(SCON,
			makeInfo myLoc (SCONleft, SCONright)) ))
 in (LrTable.NT 43,(result,SCON1left,SCON1right),rest671) end
| (135,(_,(MlyValue.seq_ty seq_ty2,_,seq_ty2right))::_::(_,(
MlyValue.seq_ty seq_ty1,seq_ty1left,_))::rest671) => let val result=
MlyValue.ty((
 Absyn.RELty(seq_ty1, seq_ty2,
			makeInfo myLoc (seq_ty1left, seq_ty2right)) 
))
 in (LrTable.NT 44,(result,seq_ty1left,seq_ty2right),rest671) end
| (136,(_,(MlyValue.tuple_ty tuple_ty,tuple_ty1left,tuple_ty1right))::
rest671) => let val result=MlyValue.ty(( mktuplety(tuple_ty) ))
 in (LrTable.NT 44,(result,tuple_ty1left,tuple_ty1right),rest671) end
| (137,(_,(MlyValue.tuple_ty tuple_ty,_,tuple_ty1right))::_::(_,(
MlyValue.ty_sans_star ty_sans_star,ty_sans_star1left,_))::rest671) => 
let val result=MlyValue.tuple_ty(( ty_sans_star :: tuple_ty ))
 in (LrTable.NT 45,(result,ty_sans_star1left,tuple_ty1right),rest671)
 end
| (138,(_,(MlyValue.ty_sans_star ty_sans_star,ty_sans_star1left,
ty_sans_star1right))::rest671) => let val result=MlyValue.tuple_ty((
 [ty_sans_star] ))
 in (LrTable.NT 45,(result,ty_sans_star1left,ty_sans_star1right),
rest671) end
| (139,(_,(MlyValue.longorshortid longorshortid,_,longorshortidright
 as longorshortid1right))::(_,(MlyValue.ty_sans_star ty_sans_star,
ty_sans_starleft as ty_sans_star1left,_))::rest671) => let val result=
MlyValue.ty_sans_star((
 Absyn.CONSty([ty_sans_star], longorshortid,
			makeInfo myLoc (ty_sans_starleft, longorshortidright)) 
))
 in (LrTable.NT 46,(result,ty_sans_star1left,longorshortid1right),
rest671) end
| (140,(_,(MlyValue.longorshortid longorshortid,_,longorshortidright
 as longorshortid1right))::_::(_,(MlyValue.ty_comma_seq2 ty_comma_seq2
,_,_))::(_,(_,LPARENleft as LPAREN1left,_))::rest671) => let val 
result=MlyValue.ty_sans_star((
 Absyn.CONSty(ty_comma_seq2, longorshortid,
			makeInfo myLoc (LPARENleft, longorshortidright)) 
))
 in (LrTable.NT 46,(result,LPAREN1left,longorshortid1right),rest671)
 end
| (141,(_,(_,_,RPAREN1right))::(_,(MlyValue.ty ty,_,_))::(_,(_,
LPAREN1left,_))::rest671) => let val result=MlyValue.ty_sans_star((
 ty ))
 in (LrTable.NT 46,(result,LPAREN1left,RPAREN1right),rest671) end
| (142,(_,(MlyValue.tyvar tyvar,tyvarleft as tyvar1left,tyvarright as 
tyvar1right))::rest671) => let val result=MlyValue.ty_sans_star((
 Absyn.VARty(tyvar, makeInfo myLoc (tyvarleft, tyvarright)) ))
 in (LrTable.NT 46,(result,tyvar1left,tyvar1right),rest671) end
| (143,(_,(MlyValue.longorshortid longorshortid,longorshortidleft as 
longorshortid1left,longorshortidright as longorshortid1right))::
rest671) => let val result=MlyValue.ty_sans_star((
 Absyn.CONSty([], longorshortid,
			makeInfo myLoc (longorshortidleft, longorshortidright)) 
))
 in (LrTable.NT 46,(result,longorshortid1left,longorshortid1right),
rest671) end
| (144,(_,(MlyValue.ty_comma_seq2 ty_comma_seq2,_,ty_comma_seq21right)
)::_::(_,(MlyValue.ty ty,ty1left,_))::rest671) => let val result=
MlyValue.ty_comma_seq2(( ty :: ty_comma_seq2 ))
 in (LrTable.NT 47,(result,ty1left,ty_comma_seq21right),rest671) end
| (145,(_,(MlyValue.ty ty2,_,ty2right))::_::(_,(MlyValue.ty ty1,
ty1left,_))::rest671) => let val result=MlyValue.ty_comma_seq2((
 [ty1, ty2] ))
 in (LrTable.NT 47,(result,ty1left,ty2right),rest671) end
| (146,(_,(_,_,RPAREN1right))::(_,(_,LPAREN1left,_))::rest671) => let 
val result=MlyValue.seq_ty(( [] ))
 in (LrTable.NT 48,(result,LPAREN1left,RPAREN1right),rest671) end
| (147,(_,(_,_,RPAREN1right))::(_,(MlyValue.ty_comma_seq2 
ty_comma_seq2,_,_))::(_,(_,LPAREN1left,_))::rest671) => let val result
=MlyValue.seq_ty(( ty_comma_seq2 ))
 in (LrTable.NT 48,(result,LPAREN1left,RPAREN1right),rest671) end
| (148,(_,(MlyValue.tuple_ty tuple_ty,tuple_ty1left,tuple_ty1right))::
rest671) => let val result=MlyValue.seq_ty(( [mktuplety(tuple_ty)] ))
 in (LrTable.NT 48,(result,tuple_ty1left,tuple_ty1right),rest671) end
| (149,rest671) => let val result=MlyValue.tyvarseq(( [] ))
 in (LrTable.NT 49,(result,defaultPos,defaultPos),rest671) end
| (150,(_,(MlyValue.tyvar tyvar,tyvar1left,tyvar1right))::rest671) => 
let val result=MlyValue.tyvarseq(( [tyvar] ))
 in (LrTable.NT 49,(result,tyvar1left,tyvar1right),rest671) end
| (151,(_,(_,_,RPAREN1right))::(_,(MlyValue.tyvar_comma_plus 
tyvar_comma_plus,_,_))::(_,(_,LPAREN1left,_))::rest671) => let val 
result=MlyValue.tyvarseq(( tyvar_comma_plus ))
 in (LrTable.NT 49,(result,LPAREN1left,RPAREN1right),rest671) end
| (152,(_,(MlyValue.tyvar_comma_plus tyvar_comma_plus,_,
tyvar_comma_plus1right))::_::(_,(MlyValue.tyvar tyvar,tyvar1left,_))::
rest671) => let val result=MlyValue.tyvar_comma_plus((
 tyvar :: tyvar_comma_plus ))
 in (LrTable.NT 50,(result,tyvar1left,tyvar_comma_plus1right),rest671)
 end
| (153,(_,(MlyValue.tyvar tyvar,tyvar1left,tyvar1right))::rest671) => 
let val result=MlyValue.tyvar_comma_plus(( [tyvar] ))
 in (LrTable.NT 50,(result,tyvar1left,tyvar1right),rest671) end
| (154,(_,(MlyValue.ident ident2,_,ident2right))::_::(_,(
MlyValue.ident ident1,ident1left,_))::rest671) => let val result=
MlyValue.longid((
 Absyn.LONGID(SOME ident1, ident2,
			makeInfo myLoc (ident1left, ident2right)) 
))
 in (LrTable.NT 51,(result,ident1left,ident2right),rest671) end
| (155,(_,(MlyValue.longid longid,longid1left,longid1right))::rest671)
 => let val result=MlyValue.longorshortid(( longid ))
 in (LrTable.NT 52,(result,longid1left,longid1right),rest671) end
| (156,(_,(MlyValue.ident ident,identleft as ident1left,identright as 
ident1right))::rest671) => let val result=MlyValue.longorshortid((
 Absyn.LONGID(NONE, ident, 
			makeInfo myLoc (identleft, identright)) 
))
 in (LrTable.NT 52,(result,ident1left,ident1right),rest671) end
| (157,(_,(MlyValue.IDENT IDENT,IDENTleft as IDENT1left,IDENTright as 
IDENT1right))::rest671) => let val result=MlyValue.ident((
 Absyn.makeIdent(IDENT, 
			makeInfo myLoc (IDENTleft, IDENTright)) ))
 in (LrTable.NT 53,(result,IDENT1left,IDENT1right),rest671) end
| (158,(_,(MlyValue.TYVAR TYVAR,TYVARleft as TYVAR1left,TYVARright as 
TYVAR1right))::rest671) => let val result=MlyValue.tyvar((
 Absyn.makeIdent(TYVAR, 
			makeInfo myLoc (TYVARleft, TYVARright)) ))
 in (LrTable.NT 54,(result,TYVAR1left,TYVAR1right),rest671) end
| _ => raise (mlyAction i392)
end
val void = MlyValue.VOID
val extract = fn a => (fn MlyValue.module x => x
| _ => let exception ParseInternal
	in raise ParseInternal end) a 
end
end
structure Tokens : RML_TOKENS =
struct
type svalue = ParserData.svalue
type ('a,'b) token = ('a,'b) Token.token
fun AMPERSAND (p1,p2) = Token.TOKEN (ParserData.LrTable.T 0,(
ParserData.MlyValue.VOID,p1,p2))
fun AND (p1,p2) = Token.TOKEN (ParserData.LrTable.T 1,(
ParserData.MlyValue.VOID,p1,p2))
fun AS (p1,p2) = Token.TOKEN (ParserData.LrTable.T 2,(
ParserData.MlyValue.VOID,p1,p2))
fun AXIOM (p1,p2) = Token.TOKEN (ParserData.LrTable.T 3,(
ParserData.MlyValue.VOID,p1,p2))
fun BAR (p1,p2) = Token.TOKEN (ParserData.LrTable.T 4,(
ParserData.MlyValue.VOID,p1,p2))
fun CCON (i,p1,p2) = Token.TOKEN (ParserData.LrTable.T 5,(
ParserData.MlyValue.CCON i,p1,p2))
fun COLON (p1,p2) = Token.TOKEN (ParserData.LrTable.T 6,(
ParserData.MlyValue.VOID,p1,p2))
fun COLONCOLON (p1,p2) = Token.TOKEN (ParserData.LrTable.T 7,(
ParserData.MlyValue.VOID,p1,p2))
fun COMMA (p1,p2) = Token.TOKEN (ParserData.LrTable.T 8,(
ParserData.MlyValue.VOID,p1,p2))
fun DASHES (p1,p2) = Token.TOKEN (ParserData.LrTable.T 9,(
ParserData.MlyValue.VOID,p1,p2))
fun DATATYPE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 10,(
ParserData.MlyValue.VOID,p1,p2))
fun DEFAULT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 11,(
ParserData.MlyValue.VOID,p1,p2))
fun DOT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 12,(
ParserData.MlyValue.VOID,p1,p2))
fun END (p1,p2) = Token.TOKEN (ParserData.LrTable.T 13,(
ParserData.MlyValue.VOID,p1,p2))
fun EOF_HARD (p1,p2) = Token.TOKEN (ParserData.LrTable.T 14,(
ParserData.MlyValue.VOID,p1,p2))
fun EOF_SOFT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 15,(
ParserData.MlyValue.VOID,p1,p2))
fun EQ (p1,p2) = Token.TOKEN (ParserData.LrTable.T 16,(
ParserData.MlyValue.VOID,p1,p2))
fun EQTYPE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 17,(
ParserData.MlyValue.VOID,p1,p2))
fun FAIL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 18,(
ParserData.MlyValue.VOID,p1,p2))
fun FATARROW (p1,p2) = Token.TOKEN (ParserData.LrTable.T 19,(
ParserData.MlyValue.VOID,p1,p2))
fun ICON (i,p1,p2) = Token.TOKEN (ParserData.LrTable.T 20,(
ParserData.MlyValue.ICON i,p1,p2))
fun IDENT (i,p1,p2) = Token.TOKEN (ParserData.LrTable.T 21,(
ParserData.MlyValue.IDENT i,p1,p2))
fun LBRACK (p1,p2) = Token.TOKEN (ParserData.LrTable.T 22,(
ParserData.MlyValue.VOID,p1,p2))
fun LET (p1,p2) = Token.TOKEN (ParserData.LrTable.T 23,(
ParserData.MlyValue.VOID,p1,p2))
fun LPAREN (p1,p2) = Token.TOKEN (ParserData.LrTable.T 24,(
ParserData.MlyValue.VOID,p1,p2))
fun MODULE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 25,(
ParserData.MlyValue.VOID,p1,p2))
fun NOT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 26,(
ParserData.MlyValue.VOID,p1,p2))
fun OF (p1,p2) = Token.TOKEN (ParserData.LrTable.T 27,(
ParserData.MlyValue.VOID,p1,p2))
fun RCON (i,p1,p2) = Token.TOKEN (ParserData.LrTable.T 28,(
ParserData.MlyValue.RCON i,p1,p2))
fun RELATION (p1,p2) = Token.TOKEN (ParserData.LrTable.T 29,(
ParserData.MlyValue.VOID,p1,p2))
fun RBRACK (p1,p2) = Token.TOKEN (ParserData.LrTable.T 30,(
ParserData.MlyValue.VOID,p1,p2))
fun RPAREN (p1,p2) = Token.TOKEN (ParserData.LrTable.T 31,(
ParserData.MlyValue.VOID,p1,p2))
fun RULE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 32,(
ParserData.MlyValue.VOID,p1,p2))
fun SCON (i,p1,p2) = Token.TOKEN (ParserData.LrTable.T 33,(
ParserData.MlyValue.SCON i,p1,p2))
fun STAR (p1,p2) = Token.TOKEN (ParserData.LrTable.T 34,(
ParserData.MlyValue.VOID,p1,p2))
fun START_MODULE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 35,(
ParserData.MlyValue.VOID,p1,p2))
fun START_INTERFACE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 36,(
ParserData.MlyValue.VOID,p1,p2))
fun TYPE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 37,(
ParserData.MlyValue.VOID,p1,p2))
fun TYVAR (i,p1,p2) = Token.TOKEN (ParserData.LrTable.T 38,(
ParserData.MlyValue.TYVAR i,p1,p2))
fun VAL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 39,(
ParserData.MlyValue.VOID,p1,p2))
fun WILD (p1,p2) = Token.TOKEN (ParserData.LrTable.T 40,(
ParserData.MlyValue.VOID,p1,p2))
fun WITH (p1,p2) = Token.TOKEN (ParserData.LrTable.T 41,(
ParserData.MlyValue.VOID,p1,p2))
fun WITHTYPE (p1,p2) = Token.TOKEN (ParserData.LrTable.T 42,(
ParserData.MlyValue.VOID,p1,p2))
fun ADD_INT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 43,(
ParserData.MlyValue.VOID,p1,p2))
fun SUB_INT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 44,(
ParserData.MlyValue.VOID,p1,p2))
fun NEG_INT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 45,(
ParserData.MlyValue.VOID,p1,p2))
fun DIV_INT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 46,(
ParserData.MlyValue.VOID,p1,p2))
fun MOD_INT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 47,(
ParserData.MlyValue.VOID,p1,p2))
fun EQ_INT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 48,(
ParserData.MlyValue.VOID,p1,p2))
fun GE_INT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 49,(
ParserData.MlyValue.VOID,p1,p2))
fun GT_INT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 50,(
ParserData.MlyValue.VOID,p1,p2))
fun LE_INT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 51,(
ParserData.MlyValue.VOID,p1,p2))
fun LT_INT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 52,(
ParserData.MlyValue.VOID,p1,p2))
fun NE_INT (p1,p2) = Token.TOKEN (ParserData.LrTable.T 53,(
ParserData.MlyValue.VOID,p1,p2))
fun ADD_REAL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 54,(
ParserData.MlyValue.VOID,p1,p2))
fun SUB_REAL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 55,(
ParserData.MlyValue.VOID,p1,p2))
fun NEG_REAL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 56,(
ParserData.MlyValue.VOID,p1,p2))
fun MUL_REAL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 57,(
ParserData.MlyValue.VOID,p1,p2))
fun DIV_REAL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 58,(
ParserData.MlyValue.VOID,p1,p2))
fun MOD_REAL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 59,(
ParserData.MlyValue.VOID,p1,p2))
fun POW_REAL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 60,(
ParserData.MlyValue.VOID,p1,p2))
fun EQ_REAL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 61,(
ParserData.MlyValue.VOID,p1,p2))
fun GE_REAL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 62,(
ParserData.MlyValue.VOID,p1,p2))
fun GT_REAL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 63,(
ParserData.MlyValue.VOID,p1,p2))
fun LE_REAL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 64,(
ParserData.MlyValue.VOID,p1,p2))
fun LT_REAL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 65,(
ParserData.MlyValue.VOID,p1,p2))
fun NE_REAL (p1,p2) = Token.TOKEN (ParserData.LrTable.T 66,(
ParserData.MlyValue.VOID,p1,p2))
fun ADD_STRING (p1,p2) = Token.TOKEN (ParserData.LrTable.T 67,(
ParserData.MlyValue.VOID,p1,p2))
fun ADD_LIST (p1,p2) = Token.TOKEN (ParserData.LrTable.T 68,(
ParserData.MlyValue.VOID,p1,p2))
end
end
