/* parsutil.h */
enum uop { UOP_ADDR, UOP_INDIR, UOP_NOT, UOP_PLUS, UOP_MINUS };
enum bop { BOP_ADD, BOP_SUB, BOP_MUL, BOP_RDIV, BOP_IDIV, BOP_IMOD, BOP_IAND, BOP_IOR };
enum rop { ROP_LT, ROP_LE, ROP_GE, ROP_GT };
enum eop { EOP_EQ, EOP_NE };

rml_value_t* pu_Constant_INTcon(rml_value_t* icon);
rml_value_t* pu_Constant_REALcon(rml_value_t* rcon);
rml_value_t* pu_Constant_IDENTcon(rml_value_t* id);
rml_value_t* pu_CONBND(rml_value_t* id, rml_value_t* con);
rml_value_t* pu_Ty_NAME(rml_value_t* id);
rml_value_t* pu_Ty_PTR(rml_value_t* ty);
rml_value_t* pu_Ty_ARR(rml_value_t* con, rml_value_t* ty);
rml_value_t* pu_Ty_REC(rml_value_t* tybnds);
rml_value_t* pu_VARBND(rml_value_t* id, rml_value_t* ty);
rml_value_t* pu_TYBND(rml_value_t* id, rml_value_t* ty);
rml_value_t* pu_Exp_INT(rml_value_t* icon);
rml_value_t* pu_Exp_REAL(rml_value_t* rcon);
rml_value_t* pu_Exp_IDENT(rml_value_t* id);
rml_value_t* pu_Exp_CAST(rml_value_t* ty, rml_value_t* exp);
rml_value_t* pu_Exp_FIELD(rml_value_t* exp, rml_value_t* id);
rml_value_t* pu_Exp_UNARY(enum uop uop, rml_value_t* exp);
rml_value_t* pu_Exp_BINARY(rml_value_t* exp1, enum bop bop, rml_value_t* exp2);
rml_value_t* pu_Exp_RELATION(rml_value_t* exp1, enum rop rop, rml_value_t* exp2);
rml_value_t* pu_Exp_EQUALITY(rml_value_t* exp1, enum eop eop, rml_value_t* exp2);
rml_value_t* pu_Exp_FCALL(rml_value_t* id, rml_value_t* args);
rml_value_t* pu_Stmt_ASSIGN(rml_value_t* lhs, rml_value_t* rhs);
rml_value_t* pu_Stmt_PCALL(rml_value_t* id, rml_value_t* args);
rml_value_t* pu_Stmt_FRETURN(rml_value_t* exp);
rml_value_t* pu_Stmt_PRETURN(void);
rml_value_t* pu_Stmt_WHILE(rml_value_t* exp, rml_value_t* stmt);
rml_value_t* pu_Stmt_IF(rml_value_t* exp, rml_value_t* stmt1, rml_value_t* stmt2);
rml_value_t* pu_Stmt_SEQ(rml_value_t* stmt1, rml_value_t* stmt2);
rml_value_t* pu_Stmt_SKIP(void);
rml_value_t* pu_SubBnd_FUNCBND(rml_value_t* id, rml_value_t* varbnds, rml_value_t* ty, rml_value_t* block_opt);
rml_value_t* pu_SubBnd_PROCBND(rml_value_t* id, rml_value_t* varbnds, rml_value_t* block_opt);
rml_value_t* pu_BLOCK(rml_value_t* conbnds, rml_value_t* tybnds, rml_value_t* varbnds, rml_value_t* subbnds, rml_value_t* stmt);
rml_value_t* pu_PROG(rml_value_t* id, rml_value_t* block);
