/* debug-print.c */
#include <stdio.h>
#include "rml.h"

RML_BEGIN_LABEL(RML__debug_5fprint)
{
	void *str = rmlA0;
	if (execution_type == RMLDB_STEP || rmldb_show == RMLDB_SHOW)
	{
		rmldb_sprintf ("%s=[", RML_STRINGDATA(str));
		rml_var_print(rmlA1);
		rmldb_sprintf ("]\n");
	}
	RML_TAILCALLK(rmlSC);
}
RML_END_LABEL

void rml_var_print(void *p)
{
tail_recur_debug:
	/* rmldb_sprintf("[%p]", p); */
	if (!p) { rmldb_sprintf ("NIL"); fflush(stdout); return; }
	if( RML_ISIMM(p) ) 
	{
		rmldb_sprintf ("%d", RML_UNTAGFIXNUM(p));    
	} 
	else 
	{
		rml_uint_t phdr = RML_GETHDR(p);            
		if( phdr == RML_REALHDR ) 
		{
			rmldb_sprintf ("%f", rml_prim_get_real(p));
			fflush(stdout);
		} else 
			if( RML_HDRISSTRING(phdr) ) 
			{
				rmldb_sprintf ("\"%s\"", RML_STRINGDATA(p));
				fflush(stdout);
				/* use if neccesarry RML_HDRSTRLEN(phdr) */
			} else 
				if( RML_HDRISSTRUCT(phdr) ) 
				{
					rml_uint_t slots = RML_HDRSLOTS(phdr);
					rml_uint_t constr = RML_HDRCTOR(phdr);
					if (slots == 0)
					{
						rmldb_sprintf ("{S(%d)[%d]=NIL}", constr, slots);
						fflush(stdout);
						return;
					}
					
					rmldb_sprintf ("S(%d)[%d](", constr, slots);

					void **pp = RML_STRUCTDATA(p);
					fflush(stdout);
					// function definition
					if ((constr == 64 || constr==13) &&
						slots > 1000000) return;
					if( slots != 0 )
					{
						// rmldb_sprintf ("\n\t"); 
						while( --slots > 0 )
						{
							rml_var_print(*pp++);
							rmldb_sprintf (",");
							fflush(stdout);
						}
						p = *pp; 
						rml_var_print(*pp); rmldb_sprintf (")"); fflush(stdout);
						// goto tail_recur_debug;  
					}					    
				} 
				else 
				{
					rmldb_sprintf ("UNKNOWN"); fflush(stdout);
				}
	}
}

static unsigned long rml_var_size = 0;

unsigned long rml_get_var_size(void *p)
{
tail_recur_debug:
	if (!p) { return 0; }
	if( RML_ISIMM(p) ) 
	{
		return sizeof(void*);
	} 
	else 
	{
		rml_uint_t phdr = RML_GETHDR(p);            
		if( phdr == RML_REALHDR ) 
		{
			return sizeof(struct rml_real);
		} else 
			if( RML_HDRISSTRING(phdr) ) 
			{
				return RML_HDRSTRLEN(phdr);
			} else 
				if( RML_HDRISSTRUCT(phdr) ) 
				{
					rml_uint_t slots = RML_HDRSLOTS(phdr);
					rml_uint_t constr = RML_HDRCTOR(phdr);
					if (slots == 0)
					{
						return sizeof(struct rml_header);
					}
					void **pp = RML_STRUCTDATA(p);
					// function definition
					if ((constr == 64 || constr==13) && slots > 1000000) 
						return sizeof(struct rml_header);
					if( slots != 0 )
					{
						while( --slots > 0 )
						{
							rml_var_size += rml_get_var_size(*pp++);
						}
						p = *pp; 
						rml_var_size += rml_get_var_size(*pp); 
					}					    
				} 
				else 
				{
					return sizeof(struct rml_ref);
				}
	}
}

unsigned long rml_var_sizeof(void *p)
{
	rml_var_size = 0;
	unsigned long result = rml_get_var_size(p);
	if (rml_var_size == 0) return result;
	else return rml_var_size;
}

