%{
    
#include "rml-debug.h"

extern int aarmldblex(void);

#define YYDEBUG 1
#define YYERROR_VERBOSE                  /* Have this defined to give better
                                            error messages. Using it causes
					    some bison warnings at compiler
					    compile time, however. Use as you
					    wish. Not mandatory. */
%}


/* The different semantic values that can be $$  = ed within the AST. 
 */
 
%union 
{
  int vint;
  char *vid;
  rml_type_t *vtyp;
  rmlLISTty_t *vtyplist;
  rml_range_db_t *vrangep;
}

/* uncomment this shit on linux and comment it on solaris
   damn incompatibilities
*/
/* %name-prefix="rml-db-" */

/* Here are $$  =  types for all productions that $$  =  nodes (ie, the
   $$  =  type of the bison $$ construct).
   (hint: maybe $$ has the type YYSTYPE?). */
%token T_EOF T_EOL
%token T_VAL T_CON T_TYPE T_RELATION T_RANGE 
%token T_LBRACK T_RBRACK T_FATARROW T_DOT T_MORE T_COLON
%token T_LPAR T_RPAR T_COMMA T_STAR

%token <vid>T_id
%token <vid>T_tyvar
%token <vint>T_number

%type <vrangep> range
/*
%nonterm ty of Absyn.ty
	   | ty_sans_star of Absyn.ty
	   | tuple_ty of Absyn.ty list
	   | ty_comma_seq2 of Absyn.ty list
	   | seq_ty of Absyn.ty list
*/
%type <vtyp> ty ty_sans_star
%type <vtyplist> tuple_ty ty_comma_seq2 seq_ty  

/* %type <vvoidp> tyvarseq tyvar_comma_plus */

/* v: main.rml:99.53.99.57|range[97.9.99.86]|buildNormalAst[stmts:Absyn.Stmt list]
 * t: values.rml:40.12.40.16|Values.Value
 * c: values.rml:47.20.47.25|Values.RECORD:(Values.Value list,string list) => Values.Value
 * r: values.rml:428.10.428.20|Values.mult_matrix:(Values.Value list,Values.Value list) => Values.Value list */
/*
	| <<EOF>>
	{
	   YYACCEPT;
	}	
	%start lines

*/

%%

lines:
	| line T_EOL lines
	| T_EOF
	{
		YYACCEPT;
	}  
    ;
    
line:
T_VAL T_id T_COLON range T_MORE T_RANGE T_LBRACK range T_RBRACK T_MORE T_id T_LBRACK T_id T_COLON ty T_RBRACK 
{
	/* v: main.rml:99.53.99.57|range[97.9.99.86]|buildNormalAst[stmts:Absyn.Stmt list] */
	rml_var_db_t* rml_var_db_node = 
		make_rml_var_db($2, $4, $8, $11, $13, 
			make_rml_type_db_t($15));		
	rml_var_db_add(&rml_var_db_start, &rml_var_db_end, rml_var_db_node);
	/*
	fprintf(stderr, "file[%s],relation[%s],variabile[%s] -> ",$2,$11,$13);
	rml_print_type($15, stderr);
	fprintf(stderr,"\n");
	*/
}
| T_CON T_id T_COLON range T_MORE T_id T_COLON ty
{
	/* c: values.rml:47.20.47.25|Values.RECORD:(Values.Value list,string list) => Values.Value */
	rml_con_db_t* rml_con_db_node = 
		make_rml_con_db($2, $4, $6, 
			make_rml_type_db_t($8),0);		
	rml_con_db_add(&rml_con_db_start, &rml_con_db_end, rml_con_db_node); 
	/*
	printf("file[%s],con[%s],type[%p]=>type[$p]",$2,$6,$7); 
	*/
}
| T_TYPE T_id T_COLON range T_MORE T_id
{
	/* t: values.rml:40.12.40.16|Values.Value */
	rml_type_db_t* rml_type_db_node = make_rml_type_db($2, $4, $6);	
	rml_type_db_add(&rml_type_db_start, &rml_type_db_end, rml_type_db_node); 
	/*
	printf("file[%s],type[%p]",$2,$6); 
	*/
}
| T_RELATION T_id T_COLON range T_MORE T_id T_COLON ty
{
	/* r: values.rml:428.10.428.20|Values.mult_matrix:(Values.Value list,Values.Value list) => Values.Value list */
	rml_relation_db_t* rml_relation_db_node = 
		make_rml_relation_db($2, $4, $6, 
			make_rml_type_db_t($8));
	rml_relation_db_add(&rml_relation_db_start, &rml_relation_db_end, rml_relation_db_node); 
	/*
	printf("file[%s],relation[%s],type[%p]",$2,$6,$8);  
	*/
}
;

range: 
	T_number T_DOT T_number T_DOT T_number T_DOT T_number
	{
	  rml_range_db_t *pRange;
	  pRange = (rml_range_db_t*) malloc (sizeof(rml_range_db_t));
	  /* printf ("%d,%d,%d,%d", $1, $3, $5, $7); */
	  pRange->sl = $1; pRange->sc = $3;
	  pRange->el = $5; pRange->ec = $7;
	  $$  = pRange;
	}
	;
	
/*
    excerpt from rml.grm
    datatype ident	= IDENT of string * info ref
    type tyvar		= ident
    datatype longid	= LONGID of ident option * ident
    datatype ty	= VARty of tyvar
				| CONSty of ty list * longid
				| TUPLEty of ty list
				| RELty of ty list * ty list
%nonterm ty of Absyn.ty
	   | ty_sans_star of Absyn.ty
	   | tuple_ty of Absyn.ty list	   
	   | ty_comma_seq2 of Absyn.ty list
	   | seq_ty of Absyn.ty list
*/

ty
	: seq_ty T_FATARROW seq_ty
	{
	  /* 
	  Absyn.RELty(seq_ty1, seq_ty2) 
	  printf ("Ty.REL(%p,%p)",$1,$3);
	  */
	  $$  = make_rml_type(eRELty, (void*)make_rmlRELty($1, $3));
    }
	| tuple_ty
	{
		/* 
		mktuplety(tuple_ty)
		printf ("Ty.TUPLE(%p)",$1);
		*/
		if ($1->length > 1)
			$$ = make_rml_type(eTUPLEty, (void*)make_rmlTUPLEty($1));
		else 
			$$  = $1->list_start;
	}
	;

tuple_ty
	: ty_sans_star T_STAR tuple_ty
	{
	   /* 
	   ty_sans_star :: tuple_ty 
	   printf ("Ty.LIST(%p,%p)",$1,$3);
	   */
	  $$ = make_cons_rmlLISTty($1,$3);
	}
	| ty_sans_star
	{
		/* 
		[ty_sans_star]
	    printf ("Ty.LIST(%p)",$1);
	    */		
		$$  =  make_rmlLISTty($1,NULL);
	}

ty_sans_star
	: ty_sans_star T_id
	{
	  /* 
	  ( Absyn.CONSty([ty_sans_star], longorshortid) 
	  printf ("Ty.CONSty(list:%p,%s)",$1,$2);		
	  */
	  $$  =  make_rml_type(eCONSty, 
				(void*)make_rmlCONSty(make_rmlLISTty($1,NULL), $2));
	}
	| T_LPAR ty_comma_seq2 T_RPAR T_id
	{
		/*
		printf ("(Ty.CONSty(list:%p,%s))",$2,$4); 
		( Absyn.CONSty(ty_comma_seq2, longorshortid) 
		*/	
	    $$  =  make_rml_type(eCONSty, (void*)make_rmlCONSty($2,$4));
	}
	| T_LPAR ty T_RPAR
	{
	  /* 
	  ty 
	  printf ("Ty(:%p)",$2);
	  */	  
	  $$  =  $2;
	}
	| T_tyvar
	{
		/* 
	    printf ("Tyvar(:%p)",$1);	  
		( Absyn.VARty(tyvar, makeInfo myLoc (tyvarleft, tyvarright)) ) 
		*/
		$$  =  make_rml_type(eVARty, (void*)make_rmlVARty($1));
	}	
	| T_id
	{
		/* 		
		( Absyn.CONSty([], longorshortid,
	    printf ("Ty.CONSty(:%s)",$1);	  	
	    */
		$$  =  make_rml_type(eCONSty, (void*)make_rmlCONSty(make_rmlLISTty(NULL,NULL), $1));
	}
	;

ty_comma_seq2
	: ty T_COMMA ty_comma_seq2
	{	  	
		/* 
		( ty :: ty_comma_seq2 )
		printf ("TyList(:%p,%p)",$1,$3); 
		*/
	  	$$ = make_cons_rmlLISTty($1,$3);
	}
	| ty T_COMMA ty
	{
		/* 
		( [ty1, ty2] ) 
		printf ("TyList(:%p,%p)",$1,$3);
		*/
	  	$$ = make_rmlLISTty($1,$3);
	}
	;

seq_ty
	: T_LPAR T_RPAR
	{ 
		/*
		([])
		printf ("seq_ty_empty");
		*/		
		$$ = make_rmlLISTty(NULL, NULL); 
	}
	| T_LPAR ty_comma_seq2 T_RPAR
	{
		/* 
		printf ("(Ty_comma_seq2(%p))",$2);
		( ty_comma_seq2 ) 
		*/
		$$  =  $2;
	}
	| tuple_ty
	{
		/*
		printf ("Ty.TUPLE(%p)",$1);	
		( [mktuplety(tuple_ty)] ) 
		*/
		if ($1->length > 1)
			$$ = make_rmlLISTty(make_rml_type(eTUPLEty, (void*)make_rmlTUPLEty($1)),NULL);
		else 
			$$  = make_rmlLISTty($1->list_start,NULL);
	}
	;


%%

int aarmldberror(char *s) 
{
  fprintf(stderr, "%s\n", s);
  return  -1;
}
