%{

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include "rml.h"
#include "rml-db-parse.h"

int rml_db_lineno = 1;

/* %option always-interactive */
%}


%option 8bit
%option caseless
%option nodefault
%option outfile = "rml-db-scan.c"
%option prefix = "aarmldb"
%option noyywrap
/* %option yylineno */

LETTER  [A-Za-z_] 
DIGIT	[0-9]
ident   {LETTER}({LETTER}|{DIGIT}|"."|"'")*
tyvar   "'"{LETTER}({LETTER}|{DIGIT}|"."|"'")*
%%

^"v:" {
	return T_VAL;
}

^"c:" {
	return T_CON;
}

^"t:" {
	return T_TYPE;
}

^"r:" {
	return T_RELATION;
}

range {
  return T_RANGE;
}

"(" {
  return T_LPAR;
}

")" {
  return T_RPAR;
}

"," {
  return T_COMMA;
}

"[" {
  return T_LBRACK;
}

"]" {
  return T_RBRACK;
}

"*" {
  return T_STAR;
}

"=>" {
 return T_FATARROW;
 }
 
"." {
return T_DOT;
}

":" {
return T_COLON;
}

"|" {
return T_MORE;
}
 
{DIGIT}+ { 
	aarmldblval.vint = atoi(aarmldbtext);
	if (aarmldbdebug) fprintf(stderr, "FLEX:[NUMBER:%s at line %d]",aarmldbtext, rml_db_lineno); 
	return T_number; 
}

{ident} { 
	aarmldblval.vid = (char*)malloc(strlen(aarmldbtext)+1);
	if (aarmldbdebug) fprintf(stderr, "FLEX:[ID:%s at line %d]",aarmldbtext, rml_db_lineno); 
	strcpy(aarmldblval.vid, aarmldbtext); 
	return T_id; 
}

{tyvar} { 
	aarmldblval.vid = (char*)malloc(strlen(aarmldbtext)+1);
	if (aarmldbdebug) fprintf(stderr, "FLEX:[TYVAR:%s at line %d]",aarmldbtext, rml_db_lineno); 
	strcpy(aarmldblval.vid, aarmldbtext);
	return T_tyvar; 
}


\n          { rml_db_lineno++; return T_EOL; }
[ \t\r\010]+	{ /* Skip whitespace */ }
<<EOF>>			{  rml_db_lineno = 1; return T_EOF; }
.				{ if (aarmldbdebug) fprintf(stderr,"FLEX:bad character: %s at line %d\n", aarmldbtext, rml_db_lineno); }
%%


